#define STRICT
//#define WIN32_LEAN_AND_MEAN

#include <windows.h>
#include "SafeWrite.h"
#include "main.h"

static const BYTE DefaultPerks=119;
static const BYTE PerksUsed=150;

static char Name[64*PerksUsed];
static char Desc[1024*PerksUsed];
static char perksFile[260];

static DWORD PlayerPerksLevels[PerksUsed];

struct PerkStruct {
	char* Name;
	char* Desc;
	int Image;
	int Ranks;
	int Level;
	int Stat;
	int StatMag;
	int Skill1;
	int Skill1Mag;
	int Type;
	int Skill2;
	int Skill2Mag;
	int Str;
	int Per;
	int End;
	int Chr;
	int Int;
	int Agl;
	int Lck;
};
//static const PerkStruct BlankPerk={ &Name[119*64], &Desc[119*1024], 0x48, 1, 1, -1, 0, -1, 0, 0, -1, 0, 0, 0, 0, 0, 0, 0, 0 };
static PerkStruct Perks[PerksUsed];

static DWORD _stdcall GetPerkLevel(DWORD critter, int perk) {
	if(perk>PerksUsed||(critter!=*(DWORD*)0x6610B8&&perk>DefaultPerks)) return 0;
	DWORD level;
	_asm {
		mov eax, critter;
		mov ebx, 0x0049678C;
		call ebx;
		mov edx, perk;
		mov eax, [eax+edx*4];
		mov level, eax;
	}
	return level;
}
static void _declspec(naked) GetPerkLevel_asm() {
	_asm {
		push eax;
		push edx;
		call GetPerkLevel;
		ret;
	}
}

static char* _stdcall GetPerkName(int perk) {
	if(perk>PerksUsed) return 0;
	else return Perks[perk].Name;
}
static void _declspec(naked) GetPerkName_asm() {
	_asm {
		push eax;
		call GetPerkName;
		ret;
	}
}

static void PerkSetup() {
	memset(Name, 0, sizeof(Name));
	memset(Desc, 0, sizeof(Desc));
	memset(PlayerPerksLevels, 0, sizeof(PlayerPerksLevels));
	memcpy(Perks, (void*)0x00519DCC, sizeof(PerkStruct)*119);

	//GetPerkLevelData
	*(DWORD*)0x51C120 = (DWORD)&PlayerPerksLevels[0];
	//SafeWrite32(0x0049679C, (DWORD)&PlayerPerksLevels[0]);

	//GetPerkLevel
	SafeWrite8(0x00496B78, 0xe9);
	HookCall(0x00496B78, GetPerkLevel_asm);
	//SafeWrite8(0x00496B7E, PerksUsed);

	//GetPerkName
	SafeWrite8(0x00496B90, 0xe9);
	HookCall(0x00496B90, GetPerkName_asm);
	//SafeWrite32(0x00496BAD, (DWORD)Perks);
	//SafeWrite8(0x00496B97, PerksUsed);

	SafeWrite32(0x00496669, (DWORD)Perks);
	SafeWrite32(0x00496837, (DWORD)Perks);
	SafeWrite32(0x00496C41, (DWORD)Perks);
	SafeWrite32(0x00496D25, (DWORD)Perks);
	SafeWrite32(0x00496696, (DWORD)Perks + 4);
	SafeWrite32(0x00496BD1, (DWORD)Perks + 4);
	SafeWrite32(0x00496BF5, (DWORD)Perks + 8);
	SafeWrite32(0x00496AD4, (DWORD)Perks + 12);

	//SafeWrite32(0x0043D19E, (DWORD)qsortbuffer);
	//SafeWrite32(0x0043D8B6, (DWORD)qsortbuffer);
	
	for(int i=0;i<119;i++) {
		strcpy_s(&Name[64*i], 64, Perks[i].Name);
		if(Perks[i].Desc) {
			strcpy_s(&Desc[1024*i], 1024, Perks[i].Desc);
		}
		Perks[i].Name=&Name[64*i];
		Perks[i].Desc=&Desc[1024*i];
	}
	for(int i=119;i<PerksUsed;i++) {
		strcpy_s(&Name[64*i], 64, "unnamed");
		Perks[i].Name=&Name[64*i];
		strcpy_s(&Desc[1024*i], 1024, "No description");
		Perks[i].Desc=&Desc[1024*i];
	}


	if(strlen(perksFile)) {
		char num[4];
		for(int i=0;i<PerksUsed;i++) {
			_itoa_s(i, num, 10);
			if(!GetPrivateProfileInt(num, "Override", 0, perksFile)) continue;
			if(GetPrivateProfileString(num, "Name", "", &Name[i*64], 63, perksFile)) Perks[i].Name=&Name[i*64];
			if(GetPrivateProfileString(num, "Desc", "", &Desc[i*1024], 1023, perksFile)) {
				Perks[i].Desc=&Desc[i*1024];
			}
			int value;
			value=GetPrivateProfileInt(num, "Image", -99999, perksFile);
			if(value!=-99999) Perks[i].Image=value;
			value=GetPrivateProfileInt(num, "Ranks", -99999, perksFile);
			if(value!=-99999) Perks[i].Ranks=value;
			value=GetPrivateProfileInt(num, "Level", -99999, perksFile);
			if(value!=-99999) Perks[i].Level=value;
			value=GetPrivateProfileInt(num, "Stat", -99999, perksFile);
			if(value!=-99999) Perks[i].Stat=value;
			value=GetPrivateProfileInt(num, "StatMag", -99999, perksFile);
			if(value!=-99999) Perks[i].StatMag=value;
			value=GetPrivateProfileInt(num, "Skill1", -99999, perksFile);
			if(value!=-99999) Perks[i].Skill1=value;
			value=GetPrivateProfileInt(num, "Skill1Mag", -99999, perksFile);
			if(value!=-99999) Perks[i].Skill1Mag=value;
			value=GetPrivateProfileInt(num, "Type", -99999, perksFile);
			if(value!=-99999) Perks[i].Type=value;
			value=GetPrivateProfileInt(num, "Skill2", -99999, perksFile);
			if(value!=-99999) Perks[i].Skill2=value;
			value=GetPrivateProfileInt(num, "Skill2Mag", -99999, perksFile);
			if(value!=-99999) Perks[i].Skill2Mag=value;
			value=GetPrivateProfileInt(num, "STR", -99999, perksFile);
			if(value!=-99999) Perks[i].Str=value;
			value=GetPrivateProfileInt(num, "PER", -99999, perksFile);
			if(value!=-99999) Perks[i].Per=value;
			value=GetPrivateProfileInt(num, "END", -99999, perksFile);
			if(value!=-99999) Perks[i].End=value;
			value=GetPrivateProfileInt(num, "CHR", -99999, perksFile);
			if(value!=-99999) Perks[i].Chr=value;
			value=GetPrivateProfileInt(num, "INT", -99999, perksFile);
			if(value!=-99999) Perks[i].Int=value;
			value=GetPrivateProfileInt(num, "AGL", -99999, perksFile);
			if(value!=-99999) Perks[i].Agl=value;
			value=GetPrivateProfileInt(num, "LCK", -99999, perksFile);
			if(value!=-99999) Perks[i].Lck=value;
		}
	}

	SafeWrite8(0x0049681E, PerksUsed);
	SafeWrite8(0x00496854, PerksUsed);
	SafeWrite8(0x00496BBB, PerksUsed);
	SafeWrite8(0x00496BDF, PerksUsed);
	SafeWrite8(0x00496C2B, PerksUsed);
	SafeWrite8(0x00496D0F, PerksUsed);
	SafeWrite8(0x00496AA8, PerksUsed);
	SafeWrite8(0x00496A68, PerksUsed);
	SafeWrite8(0x00496B6C, PerksUsed);

	SafeWrite8(0x0043437E, PerksUsed);
	SafeWrite8(0x00434383, PerksUsed);
	SafeWrite8(0x0043443F, PerksUsed);
	SafeWrite8(0x00439C3D, PerksUsed);
	SafeWrite8(0x00439C42, PerksUsed);
	SafeWrite8(0x00439D03, PerksUsed);
	SafeWrite8(0x0043A854, PerksUsed);
	SafeWrite8(0x0043AE5E, PerksUsed);
	SafeWrite8(0x0043AE63, PerksUsed);
	SafeWrite8(0x0043C2E6, PerksUsed);
	SafeWrite8(0x0043DEB3, PerksUsed);
	SafeWrite8(0x0043DEEB, PerksUsed);
	SafeWrite8(0x0043DF1A, PerksUsed);
	SafeWrite8(0x0043DF44, PerksUsed);
	SafeWrite8(0x0045823B, PerksUsed);
	SafeWrite8(0x00496B07, PerksUsed);

	SafeWrite8(0x004966A0, PerksUsed);

}
static __declspec(naked) void PerkInitWrapper() {
	_asm {
		push ecx;
		mov ecx, 0x004965A0;
		call ecx;
		pushad;
		call PerkSetup;
		popad;
		pop ecx;
		retn;
	}
}

void _stdcall SetPerkValue(int id, int value, DWORD offset) {
	if(id<0||id>=119) return;
	*(DWORD*)((DWORD)(&Perks[id])+offset)=value;
}
void _stdcall SetPerkName(int id, char* value) {
	if(id<0||id>=119) return;
	strcpy_s(&Name[id*64], 64, value);
}
void _stdcall SetPerkDesc(int id, char* value) {
	if(id<0||id>=119) return;
	strcpy_s(&Desc[id*1024], 1024, value);
	Perks[id].Desc=&Desc[1024*id];
}
void PerksInit() {
	SafeWrite32(0x0044272A, ((DWORD)&PerkInitWrapper) - 0x0044272E);
	if(GetPrivateProfileString("Misc", "PerksFile", "", &perksFile[2], 257, ini)) {
		perksFile[0]='.';
		perksFile[1]='\\';
	} else perksFile[0]=0;
}