//#define WIN32_LEAN_AND_MEAN
#define STRICT
#include <windows.h>
#ifndef WIN9X
#include <math.h>
#endif
#include "Knockback.h"
#include "safewrite.h"
#include "vector9x.cpp"

struct KnockbackModifier {
	DWORD id;
	DWORD type;
	double value;
};

static vector<KnockbackModifier> mTargets;
static vector<KnockbackModifier> mAttackers;
static vector<KnockbackModifier> mWeapons;

struct ChanceModifier {
	DWORD id;
	DWORD maximum;
	DWORD mod;
};

static vector<ChanceModifier> HitChanceMods;
static vector<ChanceModifier> SkillMaxMods;
static vector<ChanceModifier> PickpocketMods;

static ChanceModifier BaseHitChance;
static ChanceModifier BaseSkillMax;
static ChanceModifier BasePickpocket;

static double ApplyModifiers(vector<KnockbackModifier>* mods, DWORD id, double val) {
	for(DWORD i=0;i<mods->size();i++) {
		if((*mods)[i].id==id) {
			KnockbackModifier* mod=&(*mods)[i];
			switch(mod->type) {
				case 0: val=mod->value; break;
				case 1: val*=mod->value; break;
			}
			break;
		}
	}
	return val;
}
static DWORD _stdcall CalcKnockback(int flags, int damage,DWORD target,DWORD attacker,DWORD weapon) {
	double result=(double)damage/(flags==0x3d?5.0:10.0);
	result=ApplyModifiers(&mWeapons, weapon, result);
	result=ApplyModifiers(&mAttackers, attacker, result);
	result=ApplyModifiers(&mTargets, target, result);
	return (DWORD)floor(result);
}

//static const DWORD KnockbackRetAddr=0x00424BA2;
static const DWORD KnockbackRetAddr=0x00424B85;
static void _declspec(naked) KnockbackHook() {
	_asm {
		mov ecx, [esp+0x14];
		push ebx;
		mov ebx, [esi+8];
		push ebx;	//Weapon
		mov ebx, [esi];
		push ebx;	//Attacker
		push ecx;	//target
		mov edi, [edi];
		push edi;	//Damage
		push eax;	//Weapon flags
		call CalcKnockback;
		pop ebx;
		mov ecx, [esp+0x10];
		mov [ecx], eax;
		jmp KnockbackRetAddr;
	}
}

static const DWORD KnockbackAddr=(DWORD)&KnockbackHook;

static DWORD _stdcall PickpocketHook2(DWORD base, DWORD critter) {
	for(DWORD i=0;i<PickpocketMods.size();i++) {
		if(critter==PickpocketMods[i].id) {
			return min(base + PickpocketMods[i].mod, PickpocketMods[i].maximum);
		}
	}
	return min(base + BasePickpocket.mod, BasePickpocket.maximum);
}
static void _declspec(naked) PickpocketHook() {
	_asm {
		push edx;
		push ecx;
		push ebx;
		push esi;
		push eax;
		call PickpocketHook2;
		pop ebx;
		pop ecx;
		pop edx;
		mov [esp+84], eax;
		mov eax, 0x4ABC6F;
		jmp eax;
	}
}
static DWORD _stdcall HitChanceHook2(DWORD base, DWORD critter) {
	for(DWORD i=0;i<HitChanceMods.size();i++) {
		if(critter==HitChanceMods[i].id) {
			return min(base + HitChanceMods[i].mod, HitChanceMods[i].maximum);
		}
	}
	return min(base + BaseHitChance.mod, BaseHitChance.maximum);
}
static void _declspec(naked) HitChanceHook() {
	_asm {
		push edi;
		push esi;
		call HitChanceHook2;
		mov esi, eax;
		mov eax, 0x0042479B;
		jmp eax;
	}
}
static DWORD _stdcall SkillMaxHook2(int base, DWORD critter) {
	for(DWORD i=0;i<SkillMaxMods.size();i++) {
		if(critter==SkillMaxMods[i].id) {
			return min(base, (int)SkillMaxMods[i].maximum);
		}
	}
	return min(base, (int)BaseSkillMax.maximum);
}
static void _declspec(naked) SkillHookA() {
	_asm {
	push ecx;
	push esi;
	call SkillMaxHook2;
	mov ebx, 0x004AA64B;
	jmp ebx;
	}
}
static void _declspec(naked) SkillHookB() {
	_asm {
	push edx;
	push ecx;
	push ebx;
	push eax;
	push ecx;
	push 0xffffffff;
	call SkillMaxHook2;
	pop edx;
	cmp edx, eax;
	pop ebx;
	pop ecx;
	pop edx;
	jl win;
	mov eax, 0x4AA84E;
	jmp eax;
win:
	mov eax, 0x4AA85C;
	jmp eax;
	}
}
static const DWORD SkillHookWin=0x4AA738;
static const DWORD SkillHookFail=0x4AA72C;
static void _declspec(naked) SkillHookC() {
	_asm {
	pushad;
	push eax;
	push esi;
	push 0xffffffff;
	call SkillMaxHook2;
	pop edx;
	cmp edx, eax;
	popad;
	jl win;
	jmp SkillHookFail;
win:
	jmp SkillHookWin;
	}
}
void KnockbackInit() {
#ifdef WIN9X
	mTargets=vector<KnockbackModifier>();
	mAttackers=vector<KnockbackModifier>();
	mWeapons=vector<KnockbackModifier>();
#endif
	SafeWrite16(0x00424B61, 0x25ff);
	SafeWrite32(0x00424B63, (DWORD)&KnockbackAddr);
	SafeWrite8(0x00424791, 0xe9);
	HookCall(0x00424791, HitChanceHook);
	SafeWrite8(0x4AA63C, 0xe9);
	HookCall(0x4AA63C, SkillHookA);
	SafeWrite8(0x004AA847, 0xe9);
	HookCall(0x004AA847, SkillHookB);
	SafeWrite8(0x4AA725, 0xe9);
	HookCall(0x4AA725, SkillHookC);
	SafeWrite8(0x4ABC62, 0xe9);
	HookCall(0x4ABC62, PickpocketHook);
}
void Knockback_OnGameLoad() {
	mTargets.clear();
	mAttackers.clear();
	mWeapons.clear();
	HitChanceMods.clear();
	SkillMaxMods.clear();
	BaseHitChance.maximum=95;
	BaseSkillMax.maximum=300;
	BaseHitChance.mod=0;
	BaseSkillMax.mod=0;
}

void _stdcall KnockbackSetMod(DWORD id, DWORD type, float val, DWORD on) {
	vector<KnockbackModifier>* mods;
	switch(on) {
		case 0: mods=&mWeapons; break;
		case 1: mods=&mTargets; break;
		case 2: mods=&mAttackers; break;
	}
	KnockbackModifier mod = { id, type, (double)val };
	for(DWORD i=0;i<mods->size();i++) {
		if((*mods)[i].id==id) {
			(*mods)[i] = mod;
			return;
		}
	}
	mods->push_back(mod);
}

void _stdcall KnockbackRemoveMod(DWORD id, DWORD on) {
	vector<KnockbackModifier>* mods;
	switch(on) {
		case 0: mods=&mWeapons; break;
		case 1: mods=&mTargets; break;
		case 2: mods=&mAttackers; break;
	}
	for(DWORD i=0;i<mods->size();i++) {
		if((*mods)[i].id==id) {
			mods->remove_at(i);
			return;
		}
	}
}

void _stdcall SetSkillMax(DWORD critter, DWORD maximum) {
	if(critter==-1) {
		BaseSkillMax.maximum=maximum;
		return;
	}
	for(DWORD i=0;i<SkillMaxMods.size();i++) {
		if(critter==SkillMaxMods[i].id) {
			SkillMaxMods[i].maximum=maximum;
			return;
		}
	}
	ChanceModifier cm;
	cm.id=critter;
	cm.maximum=maximum;
	cm.mod=0;
	SkillMaxMods.push_back(cm);
}
void _stdcall SetHitChanceMax(DWORD critter, DWORD maximum, DWORD mod) {
	if(critter==-1) {
		BaseHitChance.maximum=maximum;
		BaseHitChance.mod=mod;
		return;
	}
	for(DWORD i=0;i<HitChanceMods.size();i++) {
		if(critter==HitChanceMods[i].id) {
			HitChanceMods[i].maximum=maximum;
			HitChanceMods[i].mod=mod;
			return;
		}
	}
	ChanceModifier cm;
	cm.id=critter;
	cm.maximum=maximum;
	cm.mod=mod;
	HitChanceMods.push_back(cm);
}
void _stdcall SetPickpocketMax(DWORD critter, DWORD maximum, DWORD mod) {
	if(critter==-1) {
		BasePickpocket.maximum=maximum;
		BasePickpocket.mod=mod;
		return;
	}
	for(DWORD i=0;i<PickpocketMods.size();i++) {
		if(critter==PickpocketMods[i].id) {
			PickpocketMods[i].maximum=maximum;
			PickpocketMods[i].mod=mod;
			return;
		}
	}
	ChanceModifier cm;
	cm.id=critter;
	cm.maximum=maximum;
	cm.mod=mod;
	PickpocketMods.push_back(cm);
}