#define STRICT
//#define WIN32_LEAN_AND_MEAN

#include <windows.h>
#include "SafeWrite.h"
#include "graphics.h"
#include "ScriptExtender.h"
#include "version.h"
#include "Main.h"
#include "Knockback.h"
#include "eaxfuncs.h"
#include "input.h"
#include "perks.h"

#define MAX_GLOBAL_SIZE (MaxGlobalVars*12 + 4)

static DWORD InLoop=0;
DWORD GainStatFix=0;
static DWORD SaveInCombatFix;

#define WORLDMAP   (1<<0) //0x1
#define LOCALMAP   (1<<1) //0x2 No point hooking this: would always be 1 at any point at which scripts are running
#define DIALOG     (1<<2) //0x4
#define ESCMENU    (1<<3) //0x8
#define SAVEGAME   (1<<4) //0x10
#define LOADGAME   (1<<5) //0x20
#define COMBAT     (1<<6) //0x40
#define OPTIONS    (1<<7) //0x80
#define HELP       (1<<8) //0x100
#define CHARSCREEN (1<<9) //0x200
#define PIPBOY     (1<<10)//0x400
#define PCOMBAT    (1<<11)//0x800
#define INVENTORY  (1<<12)//0x1000
#define AUTOMAP    (1<<13)//0x2000
#define SKILLDEX   (1<<14)//0x4000
#define RESERVED   (1<<31)

DWORD InWorldMap() { return (InLoop&WORLDMAP)?1:0; }
DWORD GetCurrentLoops() { return InLoop; }
#ifndef WIN9X
void ConsoleClear();
#endif

static void* DisplayMsg(char* msg) {
	_asm {
		mov eax, msg;
		mov ebx, 0x0043186C;
		call ebx;
	}
}

/*static void _declspec(naked) AddPerkHook() {
	_asm {
		push edx;
		push ebx;
		mov ebx, 0x00496A5C;
		call ebx;
		pop ebx;
		pop edx;
		cmp edx, 84;
		jl end;
		cmp edx, 90;
		jg end;
		inc ds:[edx*4 + (0x51C394 - 84*4)];
end:
		retn;
	}
}*/
static void ModifyGainXXXPerks() {
	SafeWrite8(0x004AF11F, 0xeb); //Strength
	SafeWrite8(0x004AF181, 0xeb); //Perception
	SafeWrite8(0x004AF19D, 0xeb); //Endurance
	SafeWrite8(0x004AF1BD, 0xeb); //Charisma
	SafeWrite8(0x004AF214, 0xeb); //Intelligance
	SafeWrite8(0x004AF230, 0xeb); //Agility
	SafeWrite8(0x004AF24B, 0xeb); //Luck
	//HookCall(0x0043C952, AddPerkHook);
}
static void RestoreGainXXXPerks() {
	SafeWrite8(0x004AF11F, 0x74); //Strength
	SafeWrite8(0x004AF181, 0x74); //Perception
	SafeWrite8(0x004AF19D, 0x74); //Endurance
	SafeWrite8(0x004AF1BD, 0x74); //Charisma
	SafeWrite8(0x004AF214, 0x74); //Intelligance
	SafeWrite8(0x004AF230, 0x74); //Agility
	SafeWrite8(0x004AF24B, 0x74); //Luck
	//SafeWrite32(0x0043C953, 0x0005a105);
}

static void ResetState() {
	ClearCheckedScripts();
	ClearGlobals();
#ifndef WIN9X
	ForceGraphicsRefresh(0);
	ConsoleClear();
	if(GraphicsMode>3) graphics_OnGameLoad();
#endif
	Knockback_OnGameLoad();
	InLoop=0;
	GainStatFix=0;
	RestoreGainXXXPerks();
	PerksReset();
}

static void GetSavePath(char* buf) {
	int saveid = *(int*)0x005193B8 + 1;
	char buf2[3];
	//Fallout saving is independent of working directory
	strcpy_s(buf, MAX_PATH, **(char***)0x006B24D0);
	strcat_s(buf, MAX_PATH, "\\savegame\\slot");
	_itoa_s(saveid, buf2, 10);
	if(strlen(buf2)==1) strcat_s(buf, MAX_PATH, "0");
	strcat_s(buf, MAX_PATH, buf2);
	strcat_s(buf, MAX_PATH, "\\sfallgv.sav");
}
static void _stdcall SaveGame2() {
	char buf[MAX_PATH];
	GetSavePath(buf);
	DWORD unused;
	DWORD unused2=0;
	HANDLE h=CreateFileA(buf, GENERIC_WRITE, 0, 0, CREATE_ALWAYS, 0, 0);
	if(h!=INVALID_HANDLE_VALUE) {
		SaveGlobals(h);
		WriteFile(h, &unused2, 4, &unused, 0);
		WriteFile(h, &GainStatFix, 4, &unused, 0);
		PerksSave(h);
		CloseHandle(h);
	}
}
static DWORD _stdcall combatSaveTest() {
	if(!SaveInCombatFix) return 1;
	if(InLoop&COMBAT) {
		if(!(InLoop&PCOMBAT)) {
			DisplayMsg("Cannot save at this time");
			return 0;
		}
		DWORD ap;
		DWORD bonusmove;
		_asm {
			mov edx, 8;
			mov eax, ds:[0x6610B8];
			mov ebx, 0x4AEF48;
			call ebx;
			mov ap, eax;
			mov eax, ds:[0x6610B8];
			mov edx, 3;
			mov ebx, 0x496B78;
			call ebx;
			mov bonusmove, eax;
		}
		if(*(DWORD*)(*(DWORD*)0x6610B8 + 0x40) != ap || bonusmove*2!=*(DWORD*)0x0056D39C) {
			DisplayMsg("Cannot save at this time");
			return 0;
		}
	}
	return 1;
}
static void __declspec(naked) SaveGame() {
	_asm {
		push ebx;
		push ecx;
		push edx;

		mov edx, eax;
		call combatSaveTest;
		test eax, eax;
		jz end;
		mov eax, edx;

		or InLoop, SAVEGAME;
		mov ebx, 0x0047B88C;
		call ebx;
		and InLoop, (-1^SAVEGAME);
		cmp eax, 1;
		jne end;
		call SaveGame2;
		mov eax, 1;
end:
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}


static void _stdcall LoadGame2() {
	ResetState();
#ifndef WIN9X
	SetMapEAXEnvironment();
#endif

	char buf[MAX_PATH];
	GetSavePath(buf);

	ClearGlobals();
	HANDLE h=CreateFileA(buf, GENERIC_READ, 0, 0, OPEN_EXISTING, 0, 0);
	if(h!=INVALID_HANDLE_VALUE) {
		DWORD size=0;
		DWORD unused;
		LoadGlobals(h);
		ReadFile(h, (&unused), 4, &size, 0);
		ReadFile(h, &GainStatFix, 4, &size, 0);
		if(!size) GainStatFix = 0;
		else {
			PerksLoad(h);
		}
		CloseHandle(h);
	} else {
		GainStatFix = 0;
	}

	if(GainStatFix) ModifyGainXXXPerks();
	else RestoreGainXXXPerks();

	LoadGlobalScripts();
}
static void __declspec(naked) LoadGame() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		or InLoop, LOADGAME;
		mov ebx, 0x0047C640;
		call ebx;
		/*push eax;
		push 0x0000101f;
		push 0x0045E949;
		call SafeWrite32;*/
		and InLoop, (-1^LOADGAME);
		//pop eax;
		cmp eax, 1;
		jne end;
		call LoadGame2;
		mov eax, 1;
end:

		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void NewGame2() {
	ResetState();
#ifndef WIN9X
	SetMapEAXEnvironment();
#endif

	if(GetPrivateProfileInt("Misc", "GainStatPerkFix", 1, ini)) {
		ModifyGainXXXPerks();
		GainStatFix=1;
	} else {
		RestoreGainXXXPerks();
		GainStatFix=0;
	}

	if(GetPrivateProfileInt("Misc", "PipBoyAvailableAtGameStart", 0, ini)) {
		SafeWrite8(0x00596C7B, 1);
	}
	if(GetPrivateProfileInt("Misc", "DisableHorrigan", 0, ini)) {
		*(DWORD*)0x00672E04=1;
	}

	LoadGlobalScripts();
}
static void __declspec(naked) NewGame() {
	_asm {
		pushad;
		call NewGame2;
		popad;
		push ebx;
		mov ebx, 0x00480E48;
		call ebx;
		pop ebx;
		retn;
	}
}

static void __declspec(naked) MainMenu() {
	_asm {
		pushad;
		call ResetState;
#ifndef WIN9X
		call ResetEax;
#endif
		popad;
		push ebx;
		mov ebx, 0x00481AEC;
		call ebx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) WorldMapHook() {
	_asm {
		push ebx;
		or InLoop, WORLDMAP;
		mov ebx, 0x004BFE10;
		call ebx;
		and InLoop, (-1^WORLDMAP);
		pop ebx;
		retn;
	}
}
static void __declspec(naked) CombatHook() {
	_asm {
		push ebx;
		or InLoop, COMBAT;
		mov ebx, 0x00422D2C;
		call ebx;
		and InLoop, (-1^COMBAT);
		pop ebx;
		retn;
	}
}
static void __declspec(naked) PlayerCombatHook() {
	_asm {
		push ebx;
		or InLoop, PCOMBAT;
		mov ebx, 0x004227F4;
		call ebx;
		and InLoop, (-1^PCOMBAT);
		pop ebx;
		retn;
	}
}
static void __declspec(naked) EscMenuHook() {
	_asm {
		push ebx;
		or InLoop, ESCMENU;
		mov ebx, 0x0048FC50;
		call ebx;
		and InLoop, (-1^ESCMENU);
		pop ebx;
		retn;
	}
}
static void __declspec(naked) EscMenuHook2() {
	//Bloody stupid watcom compiler optimizations...
	_asm {
		push ebx;
		or InLoop, ESCMENU;
		mov ebx, 0x0048FC48;
		call ebx;
		and InLoop, (-1^ESCMENU);
		pop ebx;
		retn;
	}
}
static void __declspec(naked) OptionsMenuHook() {
	_asm {
		push ebx;
		or InLoop, OPTIONS;
		mov ebx, 0x00490798;
		call ebx;
		and InLoop, (-1^OPTIONS);
		pop ebx;
		retn;
	}
}
static void __declspec(naked) HelpMenuHook() {
	_asm {
		push ebx;
		or InLoop, HELP;
		mov ebx, 0x00443F74;
		call ebx;
		and InLoop, (-1^HELP);
		pop ebx;
		retn;
	}
}
static void __declspec(naked) CharacterHook() {
	_asm {
		push ebx;
		or InLoop, CHARSCREEN;
		mov ebx, 0x00431DF8;
		call ebx;
		and InLoop, (-1^CHARSCREEN);
		pop ebx;
		retn;
	}
}
static void __declspec(naked) DialogHook() {
	_asm {
		push ebx;
		or InLoop, DIALOG;
		mov ebx, 0x004465C0;
		call ebx;
		and InLoop, (-1^DIALOG);
		pop ebx;
		retn;
	}
}
static void __declspec(naked) PipboyHook() {
	_asm {
		push ebx;
		or InLoop, PIPBOY;
		mov ebx, 0x00497004;
		call ebx;
		and InLoop, (-1^PIPBOY);
		pop ebx;
		retn;
	}
}
static void __declspec(naked) SkilldexHook() {
	_asm {
		push ebx;
		or InLoop, SKILLDEX;
		mov ebx, 0x004ABFD0;
		call ebx;
		and InLoop, (-1^SKILLDEX);
		pop ebx;
		retn;
	}
}
static void __declspec(naked) InventoryHook() {
	_asm {
		push ebx;
		or InLoop, INVENTORY;
		mov ebx, 0x0046E7B0;
		call ebx;
		and InLoop, (-1^INVENTORY);
		pop ebx;
		retn;
	}
}
static void __declspec(naked) AutomapHook() {
	_asm {
		push ebx;
		or InLoop, AUTOMAP;
		mov ebx, 0x0041B8BC;
		call ebx;
		and InLoop, (-1^AUTOMAP);
		pop ebx;
		retn;
	}
}

void LoadGameHookInit() {
	if(GetPrivateProfileInt("Misc", "SaveInCombatFix", 0, ini)) {
		SaveInCombatFix=1;
	} else {
		SaveInCombatFix=0;
	}

	SafeWrite32(0x00480AB4, ((DWORD)&NewGame) - 0x00480AB8);

	SafeWrite32(0x00443AE5, ((DWORD)&LoadGame) - 0x00443AE9);
	SafeWrite32(0x00443B8a, ((DWORD)&LoadGame) - 0x00443B8e);
	SafeWrite32(0x00480B78, ((DWORD)&LoadGame) - 0x00480B7c);
	SafeWrite32(0x0048FD36, ((DWORD)&LoadGame) - 0x0048FD3a);

	SafeWrite32(0x00443AAD, ((DWORD)&SaveGame) - 0x00443AB1);
	SafeWrite32(0x00443B1D, ((DWORD)&SaveGame) - 0x00443B21);
	SafeWrite32(0x0048FD00, ((DWORD)&SaveGame) - 0x0048FD04);

	SafeWrite32(0x00480A29, ((DWORD)&MainMenu) - 0x00480A2d);

	HookCall(0x00483668, WorldMapHook);
	HookCall(0x004A4073, WorldMapHook);
	HookCall(0x00426A29, CombatHook);
	HookCall(0x004432BE, CombatHook);
	HookCall(0x0045F6D2, CombatHook);
	HookCall(0x004A4020, CombatHook);
	HookCall(0x004A403D, CombatHook);
	HookCall(0x00422B09, PlayerCombatHook);
	HookCall(0x00480C16, EscMenuHook);
	HookCall(0x004433BE, EscMenuHook2);
	HookCall(0x0048FCE4, OptionsMenuHook);
	HookCall(0x0048FD17, OptionsMenuHook);
	HookCall(0x0048FD4D, OptionsMenuHook);
	HookCall(0x0048FD6A, OptionsMenuHook);
	HookCall(0x0048FD87, OptionsMenuHook);
	HookCall(0x0048FDB3, OptionsMenuHook);
	HookCall(0x00443A50, HelpMenuHook);
	HookCall(0x00443320, CharacterHook);
	HookCall(0x004A73EB, CharacterHook);
	HookCall(0x004A740A, CharacterHook);
	HookCall(0x00445748, DialogHook);
	HookCall(0x00443463, PipboyHook);
	HookCall(0x00443605, PipboyHook);
	HookCall(0x004434AC, SkilldexHook);
	HookCall(0x0044C7BD, SkilldexHook);
	HookCall(0x00443357, InventoryHook);
	HookCall(0x0044396D, AutomapHook);
	HookCall(0x00479519, AutomapHook);
}
