#define STRICT
//#define WIN32_LEAN_AND_MEAN

#include <windows.h>
#include "SafeWrite.h"
#include "main.h"
#include "Vector9x.cpp"

//static const BYTE PerksUsed=121;

static char Name[64*119];
static char Desc[1024*119];
static char perksFile[260];

static DWORD addPerkMode=2;

struct PerkStruct {
	char* Name;
	char* Desc;
	int Image;
	int Ranks;
	int Level;
	int Stat;
	int StatMag;
	int Skill1;
	int Skill1Mag;
	int Type;
	int Skill2;
	int Skill2Mag;
	int Str;
	int Per;
	int End;
	int Chr;
	int Int;
	int Agl;
	int Lck;
};
//static const PerkStruct BlankPerk={ &Name[119*64], &Desc[119*1024], 0x48, 1, 1, -1, 0, -1, 0, 0, -1, 0, 0, 0, 0, 0, 0, 0, 0 };
static PerkStruct Perks[119];

struct FakePerk {
	int Level;
	int Image;
	char Name[64];
	char Desc[1024];
};

vector<FakePerk> fakeTraits;
vector<FakePerk> fakePerks;
vector<FakePerk> fakeSelectablePerks;

extern DWORD GainStatFix;

static DWORD IgnoringDefaultPerks=0;
static char PerkBoxTitle[64];
static void _declspec(naked) GetPerkBoxTitleHook() {
	_asm {
		lea eax, PerkBoxTitle;
		ret;
	}
}
void _stdcall IgnoreDefaultPerks() { IgnoringDefaultPerks=1; }
void _stdcall RestoreDefaultPerks() { IgnoringDefaultPerks=0; }
void _stdcall SetPerkboxTitle(char* name) {
	if(name[0]=='\0') {
		SafeWrite32(0x0043C77D, 0x488cb);
	} else {
		strcpy_s(PerkBoxTitle, name);
		HookCall(0x0043C77C, GetPerkBoxTitleHook);
	}
}
void _stdcall SetSelectablePerk(char* name, int level, int image, char* desc) {
	if(level<0||level>1) return;
	if(level==0) {
		for(DWORD i=0;i<fakeSelectablePerks.size();i++) {
			if(!strcmp(name,fakeSelectablePerks[i].Name)) {
				fakeSelectablePerks.remove_at(i);
				return;
			}
		}
	} else {
		for(DWORD i=0;i<fakeSelectablePerks.size();i++) {
			if(!strcmp(name,fakeSelectablePerks[i].Name)) {
				fakeSelectablePerks[i].Level=level;
				fakeSelectablePerks[i].Image=image;
				strcpy_s(fakeSelectablePerks[i].Desc, desc);
				return;
			}
		}
		FakePerk fp;
		memset(&fp, 0, sizeof(FakePerk));
		fp.Level=level;
		fp.Image=image;
		strcpy_s(fp.Name, name);
		strcpy_s(fp.Desc, desc);
		fakeSelectablePerks.push_back(fp);
	}
}
void _stdcall SetFakePerk(char* name, int level, int image, char* desc) {
	if(level<0||level>100) return;
	if(level==0) {
		for(DWORD i=0;i<fakePerks.size();i++) {
			if(!strcmp(name,fakePerks[i].Name)) {
				fakePerks.remove_at(i);
				return;
			}
		}
	} else {
		for(DWORD i=0;i<fakePerks.size();i++) {
			if(!strcmp(name,fakePerks[i].Name)) {
				fakePerks[i].Level=level;
				fakePerks[i].Image=image;
				strcpy_s(fakePerks[i].Desc, desc);
				return;
			}
		}
		FakePerk fp;
		memset(&fp, 0, sizeof(FakePerk));
		fp.Level=level;
		fp.Image=image;
		strcpy_s(fp.Name, name);
		strcpy_s(fp.Desc, desc);
		fakePerks.push_back(fp);
	}
}
void _stdcall SetFakeTrait(char* name, int level, int image, char* desc) {
	if(level<0||level>1) return;
	if(level==0) {
		for(DWORD i=0;i<fakeTraits.size();i++) {
			if(!strcmp(name,fakeTraits[i].Name)) {
				fakeTraits.remove_at(i);
				return;
			}
		}
	} else {
		for(DWORD i=0;i<fakeTraits.size();i++) {
			if(!strcmp(name,fakeTraits[i].Name)) {
				fakeTraits[i].Level=level;
				fakeTraits[i].Image=image;
				strcpy_s(fakeTraits[i].Desc, desc);
				return;
			}
		}
		FakePerk fp;
		memset(&fp, 0, sizeof(FakePerk));
		fp.Level=level;
		fp.Image=image;
		strcpy_s(fp.Name, name);
		strcpy_s(fp.Desc, desc);
		fakeTraits.push_back(fp);
	}
}

static DWORD _stdcall HaveFakeTraits2() {
	return fakeTraits.size();
}
static void _declspec(naked) HaveFakeTraits() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		call HaveFakeTraits2;
		pop edx;
		pop ecx;
		pop ebx;
		ret;
	}
}
static DWORD _stdcall HaveFakePerks2() {
	return fakePerks.size();
}
static void _declspec(naked) HaveFakePerks() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		call HaveFakePerks2;
		pop edx;
		pop ecx;
		pop ebx;
		ret;
	}
}
static DWORD _stdcall HavefakeSelectablePerks2() {
	return fakeSelectablePerks.size();
}
static void _declspec(naked) HavefakeSelectablePerks() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		call HavefakeSelectablePerks2;
		pop edx;
		pop ecx;
		pop ebx;
		ret;
	}
}
static FakePerk* _stdcall GetFakePerk2(int id) {
	return &fakePerks[id-119];
}

static void _declspec(naked) GetFakePerk() {
	_asm {
		mov eax, [esp+4];
		push ebx;
		push ecx;
		push edx;
		push eax;
		call GetFakePerk2;
		pop edx;
		pop ecx;
		pop ebx;
		ret 4;
	}
}
static FakePerk* _stdcall GetFakeSPerk2(int id) {
	return &fakeSelectablePerks[id-119];
}

static void _declspec(naked) GetFakeSPerk() {
	_asm {
		mov eax, [esp+4];
		push ebx;
		push ecx;
		push edx;
		push eax;
		call GetFakeSPerk2;
		pop edx;
		pop ecx;
		pop ebx;
		ret 4;
	}
}
static DWORD _stdcall GetFakeSPerkLevel2(int id) {
	char* c=fakeSelectablePerks[id-119].Name;
	for(DWORD i=0;i<fakePerks.size();i++) {
		if(!strcmp(c,fakePerks[i].Name)) return fakePerks[i].Level;
	}
	return 0;
}
static void _declspec(naked) GetFakeSPerkLevel() {
	_asm {
		mov eax, [esp+4];
		push ebx;
		push ecx;
		push edx;
		push eax;
		call GetFakeSPerkLevel2;
		pop edx;
		pop ecx;
		pop ebx;
		ret 4;
	}
}

static DWORD _stdcall HandleFakeTraits(int i2) {
	for(DWORD i=0;i<fakeTraits.size();i++) {
		DWORD a=(DWORD)fakeTraits[i].Name;
		_asm {
			mov eax, a;
			mov ebx, 0x43E3D8;
			call ebx;
			mov a, eax;
		}
		if(a&&!i2) {
			i2=1;
			*(DWORD*)0x5705B0 = fakeTraits[i].Image;
			*(DWORD*)0x5705B8 = (DWORD)fakeTraits[i].Name;
			*(DWORD*)0x5705BC = 0;
			*(DWORD*)0x5705CC = (DWORD)fakeTraits[i].Desc;
		}
	}
	return i2;
}

static const DWORD GetPerkLevelAddr=0x00496B78;
static const DWORD GetPerkImageAddr=0x00496BD8;
static const DWORD GetPerkNameAddr=0x00496B90;
static const DWORD GetPerkDescAddr=0x00496BB4;
static const DWORD AddPerkAddr=0x00496A5C;

static void _declspec(naked) PlayerHasPerkHook() {
	_asm {
		push ecx;
		call HandleFakeTraits;
		mov ecx, eax;
		xor ebx, ebx;
oloop:
		mov eax, ds:[0x006610B8];
		mov edx, ebx;
		call GetPerkLevelAddr;
		test eax, eax;
		jnz win;
		inc ebx;
		cmp ebx, 119;
		jl oloop;
		call HaveFakePerks;
		test eax, eax;
		jnz win;
		mov ebx, 0x00434446;
		jmp ebx;
win:
		mov ebx, 0x0043438A;
		jmp ebx;
	}
}
static void _declspec(naked) PlayerHasTraitHook() {
	_asm {
		call HaveFakeTraits;
		test eax, eax;
		jz end;
		mov eax, 0x0043425B;
		jmp eax;
end:
		jmp PlayerHasPerkHook;
	}
}

static void _declspec(naked) GetPerkLevelHook() {
	_asm {
		cmp edx, 119;
		jl end;
		push edx;
		call GetFakePerk;
		mov eax, ds:[eax];
		ret;
end:
		jmp GetPerkLevelAddr;
	}
}

static void _declspec(naked) GetPerkImageHook() {
	_asm {
		cmp eax, 119;
		jl end;
		push eax;
		call GetFakePerk;
		mov eax, ds:[eax+4];
		ret;
end:
		jmp GetPerkImageAddr;
	}
}

static void _declspec(naked) GetPerkNameHook() {
	_asm {
		cmp eax, 119;
		jl end;
		push eax;
		call GetFakePerk;
		lea eax, ds:[eax+8];
		ret;
end:
		jmp GetPerkNameAddr;
	}
}

static void _declspec(naked) GetPerkDescHook() {
	_asm {
		cmp eax, 119;
		jl end;
		push eax;
		call GetFakePerk;
		lea eax, ds:[eax+72];
		ret;
end:
		jmp GetPerkDescAddr
	}
}

static void _declspec(naked) EndPerkLoopHook() {
	_asm {
		call HaveFakePerks;
		add eax, 119;
		cmp ebx, eax;
		jl end;
		mov eax, 0x00434446;
		jmp eax;
end:
		mov eax, 0x004343A5;
		jmp eax;
	}
}

static DWORD _stdcall HandleExtraSelectablePerks(DWORD offset, DWORD* data) {
	for(DWORD i=0;i<fakeSelectablePerks.size();i++) {
		//*(WORD*)(0x56FCB0 + (offset+i)*8)=(WORD)(119+i);
		data[offset+i]=119+i;
	}
	return offset+fakeSelectablePerks.size();
}
static void _declspec(naked) GetAvailablePerksHook() {
	_asm {
		push ecx;
		push ebx;
		push edx;
		mov ebx, IgnoringDefaultPerks;
		test ebx, ebx;
		jnz skipdefaults;
		mov ebx, 0x00496B44;
		call ebx;
		jmp next;
skipdefaults:
		xor eax, eax;
next:
		push eax;
		call HandleExtraSelectablePerks;
		pop ebx;
		pop ecx;
		ret;
	}
}
static void _declspec(naked) GetPerkSLevelHook() {
	_asm {
		cmp edx, 119;
		jl end;
		push edx;
		call GetFakeSPerkLevel;
		ret;
end:
		jmp GetPerkLevelAddr;
	}
}
static void _declspec(naked) GetPerkSImageHook() {
	_asm {
		cmp eax, 119;
		jl end;
		push eax;
		call GetFakeSPerk;
		mov eax, ds:[eax+4];
		ret;
end:
		jmp GetPerkImageAddr;
	}
}

static void _declspec(naked) GetPerkSNameHook() {
	_asm {
		cmp eax, 119;
		jl end;
		push eax;
		call GetFakeSPerk;
		lea eax, ds:[eax+8];
		ret;
end:
		jmp GetPerkNameAddr;
	}
}

static void _declspec(naked) GetPerkSDescHook() {
	_asm {
		cmp eax, 119;
		jl end;
		push eax;
		call GetFakeSPerk;
		lea eax, ds:[eax+72];
		ret;
end:
		jmp GetPerkDescAddr;
	}
}

static void _stdcall AddFakePerk(DWORD perkID) {
	perkID-=119;
	if(addPerkMode&1) {
		bool matched=false;
		for(DWORD d=0;d<fakeTraits.size();d++) {
			if(!strcmp(fakeTraits[d].Name, fakeSelectablePerks[perkID].Name)) {
				matched=true;
			}
		}
		if(!matched) fakeTraits.push_back(fakeSelectablePerks[perkID]);
	}
	if(addPerkMode&2) {
		bool matched=false;
		for(DWORD d=0;d<fakePerks.size();d++) {
			if(!strcmp(fakePerks[d].Name, fakeSelectablePerks[perkID].Name)) {
				fakePerks[d].Level++;
				matched=true;
			}
		}
		if(!matched) fakePerks.push_back(fakeSelectablePerks[perkID]);
	}
	if(addPerkMode&4) {
		fakeSelectablePerks.remove_at(perkID);
	}
}
static void _declspec(naked) AddPerkHook() {
	_asm {
		cmp edx, 119;
		jl end;
		push ecx;
		push ebx;
		push edx;
		call AddFakePerk;
		pop ebx;
		pop ecx;
		xor eax, eax;
		ret;
end:
		push edx;
		call AddPerkAddr;
		mov edx, GainStatFix;
		test edx, edx;
		pop edx;
		jz end2;
		test eax, eax;
		jnz end2;
		cmp edx, 84;
		jl end2;
		cmp edx, 90;
		jg end2;
		inc ds:[edx*4 + (0x51C394 - 84*4)];
end2:
		retn;
	}
}

static void _declspec(naked) HeaveHoHook() {
	_asm {
		xor edx, edx;
		mov eax, ecx;
		mov edi, 0x4AEF48;
		call edi;
		lea ebx, [0+eax*4];
		sub ebx, eax;
		cmp ebx, esi;
		jle lower;
		mov ebx, esi;
lower:
		mov eax, ecx;
		mov edx, 35;
		mov edi, 0x496B78;
		call edi;
		lea ecx, [0+eax*8];
		sub ecx, eax;
		sub ecx, eax;
		mov eax, ecx;
		add eax, ebx;
		mov edi, 0x478AFC;
		jmp edi;
	}
}
void _stdcall ApplyHeaveHoFix() {
	SafeWrite8(0x478AC4, 0xe9);
	HookCall(0x478AC4, HeaveHoHook);
	Perks[0x23].Str=0;
}
static void PerkSetup() {
	//Character screen
	HookCall(0x00434256, PlayerHasTraitHook);
	SafeWrite8(0x0043436B, 0xe9);
	HookCall(0x0043436B, PlayerHasPerkHook);
	HookCall(0x004343AC, GetPerkLevelHook);
	HookCall(0x004343C1, GetPerkNameHook);
	HookCall(0x004343DF, GetPerkNameHook);
	HookCall(0x0043440D, GetPerkImageHook);
	HookCall(0x0043441B, GetPerkNameHook);
	HookCall(0x00434432, GetPerkDescHook);
	SafeWrite8(0x0043443D, 0xe9);
	HookCall(0x0043443D, EndPerkLoopHook);

	//GetPlayerAvailablePerks
	HookCall(0x43D127, GetAvailablePerksHook);
	HookCall(0x43D17D, GetPerkSNameHook);
	HookCall(0x43D25E, GetPerkSLevelHook);
	HookCall(0x43D275, GetPerkSLevelHook);
	//ShowPerkBox
	HookCall(0x0043C82E, GetPerkSLevelHook);
	HookCall(0x0043C85B, GetPerkSLevelHook);
	HookCall(0x43C888, GetPerkSDescHook);
	HookCall(0x43C8A6, GetPerkSNameHook);
	HookCall(0x43C8D1, GetPerkSDescHook);
	HookCall(0x43C8EF, GetPerkSNameHook);
	HookCall(0x43C90F, GetPerkSImageHook);
	HookCall(0x43C952, AddPerkHook);
	//PerkboxSwitchPerk
	HookCall(0x43C3F1, GetPerkSLevelHook);
	HookCall(0x43C41E, GetPerkSLevelHook);
	HookCall(0x43C44B, GetPerkSDescHook);
	HookCall(0x43C469, GetPerkSNameHook);
	HookCall(0x43C494, GetPerkSDescHook);
	HookCall(0x43C4B2, GetPerkSNameHook);
	HookCall(0x43C4D2, GetPerkSImageHook);

	memset(Name, 0, sizeof(Name));
	memset(Desc, 0, sizeof(Desc));
	memcpy(Perks, (void*)0x00519DCC, sizeof(PerkStruct)*119);

	SafeWrite32(0x00496669, (DWORD)Perks);
	SafeWrite32(0x00496837, (DWORD)Perks);
	SafeWrite32(0x00496BAD, (DWORD)Perks);
	SafeWrite32(0x00496C41, (DWORD)Perks);
	SafeWrite32(0x00496D25, (DWORD)Perks);
	SafeWrite32(0x00496696, (DWORD)Perks + 4);
	SafeWrite32(0x00496BD1, (DWORD)Perks + 4);
	SafeWrite32(0x00496BF5, (DWORD)Perks + 8);
	SafeWrite32(0x00496AD4, (DWORD)Perks + 12);

	if(strlen(perksFile)) {
		char num[4];
		for(int i=0;i<119;i++) {
			_itoa_s(i, num, 10);
			if(GetPrivateProfileString(num, "Name", "", &Name[i*64], 63, perksFile)) Perks[i].Name=&Name[i*64];
			if(GetPrivateProfileString(num, "Desc", "", &Desc[i*1024], 1023, perksFile)) {
				Perks[i].Desc=&Desc[i*1024];
			}
			int value;
			value=GetPrivateProfileInt(num, "Image", -99999, perksFile);
			if(value!=-99999) Perks[i].Image=value;
			value=GetPrivateProfileInt(num, "Ranks", -99999, perksFile);
			if(value!=-99999) Perks[i].Ranks=value;
			value=GetPrivateProfileInt(num, "Level", -99999, perksFile);
			if(value!=-99999) Perks[i].Level=value;
			value=GetPrivateProfileInt(num, "Stat", -99999, perksFile);
			if(value!=-99999) Perks[i].Stat=value;
			value=GetPrivateProfileInt(num, "StatMag", -99999, perksFile);
			if(value!=-99999) Perks[i].StatMag=value;
			value=GetPrivateProfileInt(num, "Skill1", -99999, perksFile);
			if(value!=-99999) Perks[i].Skill1=value;
			value=GetPrivateProfileInt(num, "Skill1Mag", -99999, perksFile);
			if(value!=-99999) Perks[i].Skill1Mag=value;
			value=GetPrivateProfileInt(num, "Type", -99999, perksFile);
			if(value!=-99999) Perks[i].Type=value;
			value=GetPrivateProfileInt(num, "Skill2", -99999, perksFile);
			if(value!=-99999) Perks[i].Skill2=value;
			value=GetPrivateProfileInt(num, "Skill2Mag", -99999, perksFile);
			if(value!=-99999) Perks[i].Skill2Mag=value;
			value=GetPrivateProfileInt(num, "STR", -99999, perksFile);
			if(value!=-99999) Perks[i].Str=value;
			value=GetPrivateProfileInt(num, "PER", -99999, perksFile);
			if(value!=-99999) Perks[i].Per=value;
			value=GetPrivateProfileInt(num, "END", -99999, perksFile);
			if(value!=-99999) Perks[i].End=value;
			value=GetPrivateProfileInt(num, "CHR", -99999, perksFile);
			if(value!=-99999) Perks[i].Chr=value;
			value=GetPrivateProfileInt(num, "INT", -99999, perksFile);
			if(value!=-99999) Perks[i].Int=value;
			value=GetPrivateProfileInt(num, "AGL", -99999, perksFile);
			if(value!=-99999) Perks[i].Agl=value;
			value=GetPrivateProfileInt(num, "LCK", -99999, perksFile);
			if(value!=-99999) Perks[i].Lck=value;
		}
	}

	for(int i=0;i<119;i++) {
		if(Perks[i].Name!=&Name[64*i]) {
			strcpy_s(&Name[64*i], 64, Perks[i].Name);
			Perks[i].Name=&Name[64*i];
		}
		if(Perks[i].Desc&&Perks[i].Desc!=&Desc[1024*i]) {
			strcpy_s(&Desc[1024*i], 1024, Perks[i].Desc);
			Perks[i].Desc=&Desc[1024*i];
		}
	}

	/*SafeWrite8(0x0049681E, PerksUsed);
	SafeWrite8(0x00496854, PerksUsed);
	SafeWrite8(0x00496B97, PerksUsed); //This function loads perk names!
	SafeWrite8(0x00496BBB, PerksUsed);
	SafeWrite8(0x00496BDF, PerksUsed);
	SafeWrite8(0x00496C2B, PerksUsed);
	SafeWrite8(0x00496D0F, PerksUsed);
	SafeWrite8(0x00496AA8, PerksUsed);
	SafeWrite8(0x00496A68, PerksUsed);
	SafeWrite8(0x00496B6C, PerksUsed);
	SafeWrite8(0x00496B7E, PerksUsed);


	SafeWrite8(0x0043437E, PerksUsed);
	SafeWrite8(0x00434383, PerksUsed);
	SafeWrite8(0x0043443F, PerksUsed);
	SafeWrite8(0x00439C3D, PerksUsed);
	SafeWrite8(0x00439C42, PerksUsed);
	SafeWrite8(0x00439D03, PerksUsed);
	SafeWrite8(0x0043A854, PerksUsed);
	SafeWrite8(0x0043AE5E, PerksUsed);
	SafeWrite8(0x0043AE63, PerksUsed);
	SafeWrite8(0x0043C2E6, PerksUsed);
	SafeWrite8(0x0043DEB3, PerksUsed);
	SafeWrite8(0x0043DEEB, PerksUsed);
	SafeWrite8(0x0043DF1A, PerksUsed);
	SafeWrite8(0x0043DF44, PerksUsed);
	SafeWrite8(0x0045823B, PerksUsed);
	SafeWrite8(0x00496B07, PerksUsed);

	SafeWrite8(0x004966A0, PerksUsed);*/

}
static __declspec(naked) void PerkInitWrapper() {
	_asm {
		push ecx;
		mov ecx, 0x004965A0;
		call ecx;
		pushad;
		call PerkSetup;
		popad;
		pop ecx;
		retn;
	}
}

void _stdcall SetPerkValue(int id, int value, DWORD offset) {
	if(id<0||id>=119) return;
	*(DWORD*)((DWORD)(&Perks[id])+offset)=value;
}
void _stdcall SetPerkName(int id, char* value) {
	if(id<0||id>=119) return;
	strcpy_s(&Name[id*64], 64, value);
}
void _stdcall SetPerkDesc(int id, char* value) {
	if(id<0||id>=119) return;
	strcpy_s(&Desc[id*1024], 1024, value);
	Perks[id].Desc=&Desc[1024*id];
}
void PerksInit() {
#ifdef WIN9X
	fakeTraits=vector<FakePerk>();
	fakePerks=vector<FakePerk>();
	fakeSelectablePerks=vector<FakePerk>();
#endif
	SafeWrite32(0x0044272A, ((DWORD)&PerkInitWrapper) - 0x0044272E);
	if(GetPrivateProfileString("Misc", "PerksFile", "", &perksFile[2], 257, ini)) {
		perksFile[0]='.';
		perksFile[1]='\\';
	} else perksFile[0]=0;
}
void PerksReset() {
	fakeTraits.clear();
	fakePerks.clear();
	fakeSelectablePerks.clear();
	SafeWrite32(0x0043C77D, 0x488cb);
	IgnoringDefaultPerks=0;
	addPerkMode=2;
	SafeWrite8(0x478AC4, 0xe8);
	SafeWrite32(0x478AC5, 23);
}
void PerksSave(HANDLE file) {
	DWORD count;
	DWORD unused;
	count=fakeTraits.size();
	WriteFile(file, &count, 4, &unused, 0);
	for(DWORD i=0;i<count;i++) WriteFile(file, &fakeTraits[i], sizeof(FakePerk), &unused, 0);
	count=fakePerks.size();
	WriteFile(file, &count, 4, &unused, 0);
	for(DWORD i=0;i<count;i++) WriteFile(file, &fakePerks[i], sizeof(FakePerk), &unused, 0);
	count=fakeSelectablePerks.size();
	WriteFile(file, &count, 4, &unused, 0);
	for(DWORD i=0;i<count;i++) WriteFile(file, &fakeSelectablePerks[i], sizeof(FakePerk), &unused, 0);
}
bool PerksLoad(HANDLE file) {
	DWORD count;
	DWORD size;
	ReadFile(file, &count, 4, &size, 0);
	if(size!=4) return false;
	for(DWORD i=0;i<count;i++) {
		FakePerk fp;
		ReadFile(file,&fp,sizeof(FakePerk),&size,0);
		fakeTraits.push_back(fp);
	}
	ReadFile(file, &count, 4, &size, 0);
	if(size!=4) return false;
	for(DWORD i=0;i<count;i++) {
		FakePerk fp;
		ReadFile(file,&fp,sizeof(FakePerk),&size,0);
		fakePerks.push_back(fp);
	}
	ReadFile(file, &count, 4, &size, 0);
	if(size!=4) return false;
	for(DWORD i=0;i<count;i++) {
		FakePerk fp;
		ReadFile(file,&fp,sizeof(FakePerk),&size,0);
		fakeSelectablePerks.push_back(fp);
	}
	return true;
}

void _stdcall AddPerkMode(DWORD mode) {
	addPerkMode=mode;
}
DWORD _stdcall HasFakePerk(char* name) {
	for(DWORD i=0;i<fakePerks.size();i++) {
		if(!strcmp(name,fakePerks[i].Name)) {
			return fakePerks[i].Level;
		}
	}
	return 0;
}
DWORD _stdcall HasFakeTrait(char* name) {
	for(DWORD i=0;i<fakeTraits.size();i++) {
		if(!strcmp(name,fakeTraits[i].Name)) {
			return 1;
		}
	}
	return 0;
}
void _stdcall ClearSelectablePerks() {
	fakeSelectablePerks.clear();
	addPerkMode=2;
	SafeWrite32(0x0043C77D, 0x488cb);
	IgnoringDefaultPerks=0;
}