#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>
#include "ScriptExtender.h"
#include "SafeWrite.h"
#include "input.h"
#include "Graphics.h"
#include "LoadGameHook.h"
#include "version.h"
#include "main.h"
#include "perks.h"
#include "vector9x.cpp"
#include "KillCounter.h"
#include "Knockback.h"
#include "eaxfuncs.h"
#include "stats.h"

typedef void (_stdcall *regOpcodeProc)(WORD opcode,void* ptr);

static DWORD dmModelNamePtr=(DWORD)dmModelName;
static DWORD dfModelNamePtr=(DWORD)dfModelName;
static DWORD MovieNamesPtr=(DWORD)MovieNames;

static DWORD _stdcall ScriptHasLoaded(DWORD script);
static void RunGlobalScripts1();

struct sGlobalScript {
	DWORD ptr;
	DWORD count;
	DWORD repeat;
	DWORD mode; //0 - local map loop, 1 - input loop, 2 - world map loop, 3 - local and world map loops

	sGlobalScript() {}
	sGlobalScript(DWORD script) {
		ptr=script;
		count=0;
		repeat=0;
		mode=0;
	}
};
struct sGlobalVar {
	__int64 id;
	int val;

	sGlobalVar() {}
	sGlobalVar(__int64 _id, int _val) {
		id=_id;
		val=_val;
	}
};

static vector<DWORD> checkedScripts;
static vector<sGlobalScript> globalScripts;
static vector<sGlobalVar> globalVars;

static DWORD opcodes[0x200];
DWORD AddUnarmedStatToGetYear=0;
DWORD AvailableGlobalScriptTypes=0;

static const DWORD GetArgType=0x4674F0;
static const DWORD GetArg=0x467500;
static const DWORD GetStringVar=0x4678E0; //edi = script ptr, edx = var type, ebx = var
static const DWORD SetResult=0x4674DC;
static const DWORD SetResultType=0x46748C;

//eax contains the script pointer

//To read a value, mov the script pointer to eax, call 0x4674F0, eax now contains the value type
//mov the script pointer to eax, call 0x467500, eax now contains the value

//To return a value, move it to edx, mov the script pointer to eax, call 0x4674DC
//mov the value type to edx, mov the script pointer to eax, call 0x46748C

static void __declspec(naked) GetPerkOwed() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		mov ecx, eax;
		movzx edx, byte ptr ds:[0x00570A29];
		mov ebx, 0x4674DC;
		call ebx;
		mov edx, 0xc001;
		mov eax, ecx;
		mov ebx, 0x46748C;
		call ebx;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) SetPerkOwed() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz end;
		cmp eax, 250;
		jg end;
		mov byte ptr ds:[0x00570A29], al
end:
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) GetPerkAvailable() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		push esi;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz fail;
		cmp eax, 119;
		jge fail;
		mov edx, eax;
		mov eax, 0x006610B8;
		mov ebx, 0x00496B44;
		call ebx;
		mov edx, eax;
		jmp end;
fail:
		xor edx, edx;
end:
		mov eax, ecx
		mov ebx, 0x4674DC;
		call ebx;
		mov edx, 0xc001;
		mov eax, ecx;
		mov ebx, 0x46748C;
		call ebx;
		pop esi;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) funcSetPerkName() {
	_asm {
		pushad;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov esi, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		mov edi, eax;
		mov eax, ecx;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz end;
		cmp si, 0x9001;
		jz next;
		cmp si, 0x9801;
		jnz end;
next:
		mov ebx, edi;
		mov edx, esi;
		mov esi, eax;
		mov eax, ecx;
		mov edi, 0x4678E0;
		call edi;
		push eax;
		push esi;
		call SetPerkName;
		jmp end;
end:
		popad;
		retn;
	}
}
static void __declspec(naked) funcSetPerkDesc() {
	_asm {
		pushad;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov esi, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		mov edi, eax;
		mov eax, ecx;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz end;
		cmp si, 0x9001;
		jz next;
		cmp si, 0x9801;
		jnz end;
next:
		mov ebx, edi;
		mov edx, esi;
		mov esi, eax;
		mov eax, ecx;
		mov edi, 0x4678E0;
		call edi;
		push eax;
		push esi;
		call SetPerkDesc;
		jmp end;
end:
		popad;
		retn;
	}
}
static void __declspec(naked) funcSetPerkValue() {
	_asm {
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov esi, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		mov edi, eax;
		mov eax, ecx;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz fail;
		cmp si, 0xC001;
		jnz fail;
		push edi;
		push eax;
		call SetPerkValue;
		jmp end;
fail:
		add esp, 4;
end:
		popad;
		retn;
	}
}
static void __declspec(naked) SetPerkValue1() {
	_asm {
		pushad;
		push 0x08;
		jmp funcSetPerkValue;
	}
}
static void __declspec(naked) SetPerkValue2() {
	_asm {
		pushad;
		push 0x0c;
		jmp funcSetPerkValue;
	}
}
static void __declspec(naked) SetPerkValue3() {
	_asm {
		pushad;
		push 0x10;
		jmp funcSetPerkValue;
	}
}
static void __declspec(naked) SetPerkValue4() {
	_asm {
		pushad;
		push 0x14;
		jmp funcSetPerkValue;
	}
}
static void __declspec(naked) SetPerkValue5() {
	_asm {
		pushad;
		push 0x18;
		jmp funcSetPerkValue;
	}
}
static void __declspec(naked) SetPerkValue6() {
	_asm {
		pushad;
		push 0x1c;
		jmp funcSetPerkValue;
	}
}
static void __declspec(naked) SetPerkValue7() {
	_asm {
		pushad;
		push 0x20;
		jmp funcSetPerkValue;
	}
}
static void __declspec(naked) SetPerkValue8() {
	_asm {
		pushad;
		push 0x24;
		jmp funcSetPerkValue;
	}
}
static void __declspec(naked) SetPerkValue9() {
	_asm {
		pushad;
		push 0x28;
		jmp funcSetPerkValue;
	}
}
static void __declspec(naked) SetPerkValue10() {
	_asm {
		pushad;
		push 0x2c;
		jmp funcSetPerkValue;
	}
}
static void __declspec(naked) SetPerkValue11() {
	_asm {
		pushad;
		push 0x30;
		jmp funcSetPerkValue;
	}
}
static void __declspec(naked) SetPerkValue12() {
	_asm {
		pushad;
		push 0x34;
		jmp funcSetPerkValue;
	}
}
static void __declspec(naked) SetPerkValue13() {
	_asm {
		pushad;
		push 0x38;
		jmp funcSetPerkValue;
	}
}
static void __declspec(naked) SetPerkValue14() {
	_asm {
		pushad;
		push 0x3c;
		jmp funcSetPerkValue;
	}
}
static void __declspec(naked) SetPerkValue15() {
	_asm {
		pushad;
		push 0x40;
		jmp funcSetPerkValue;
	}
}
static void __declspec(naked) SetPerkValue16() {
	_asm {
		pushad;
		push 0x44;
		jmp funcSetPerkValue;
	}
}
static void __declspec(naked) SetPerkValue17() {
	_asm {
		pushad;
		push 0x48;
		jmp funcSetPerkValue;
	}
}

static void __declspec(naked) fSetSelectablePerk() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		push esi;
		mov ecx, eax;
		call GetArgType;
		push eax;
		mov eax, ecx;
		call GetArg;
		push eax;
		mov eax, ecx;
		call GetArgType;
		push eax;
		mov eax, ecx;
		call GetArg;
		push eax;
		mov eax, ecx;
		call GetArgType;
		push eax;
		mov eax, ecx;
		call GetArg;
		push eax;
		mov eax, ecx;
		call GetArgType;
		push eax;
		mov eax, ecx;
		call GetArg;
		push eax;

		movzx eax, word ptr [esp+12];
		cmp eax, 0xc001;
		jne fail;
		movzx eax, word ptr [esp+20];
		cmp eax, 0xc001;
		jne fail;
		movzx eax, word ptr ds:[esp+4];
		cmp eax, 0x9001;
		je next1;
		cmp eax, 0x9801;
		jne fail;
next1:
		movzx eax, word ptr ds:[esp+28];
		cmp eax, 0x9001;
		je next2;
		cmp eax, 0x9801;
		jne fail;
next2:
		mov eax, ecx;
		mov edx, [esp+28];
		mov ebx, [esp+24];
		call GetStringVar;
		push eax;
		mov eax, [esp+20];
		push eax;
		mov eax, [esp+16];
		push eax;
		mov eax, ecx;
		mov edx, [esp+16];
		mov ebx, [esp+12];
		call GetStringVar;
		push eax;
		
		call SetSelectablePerk;
fail:
		add esp, 32;
		pop esi;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) fSetFakePerk() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		push esi;
		mov ecx, eax;
		call GetArgType;
		push eax;
		mov eax, ecx;
		call GetArg;
		push eax;
		mov eax, ecx;
		call GetArgType;
		push eax;
		mov eax, ecx;
		call GetArg;
		push eax;
		mov eax, ecx;
		call GetArgType;
		push eax;
		mov eax, ecx;
		call GetArg;
		push eax;
		mov eax, ecx;
		call GetArgType;
		push eax;
		mov eax, ecx;
		call GetArg;
		push eax;

		movzx eax, word ptr [esp+12];
		cmp eax, 0xc001;
		jne fail;
		movzx eax, word ptr [esp+20];
		cmp eax, 0xc001;
		jne fail;
		movzx eax, word ptr ds:[esp+4];
		cmp eax, 0x9001;
		je next1;
		cmp eax, 0x9801;
		jne fail;
next1:
		movzx eax, word ptr ds:[esp+28];
		cmp eax, 0x9001;
		je next2;
		cmp eax, 0x9801;
		jne fail;
next2:
		mov eax, ecx;
		mov edx, [esp+28];
		mov ebx, [esp+24];
		call GetStringVar;
		push eax;
		mov eax, [esp+20];
		push eax;
		mov eax, [esp+16];
		push eax;
		mov eax, ecx;
		mov edx, [esp+16];
		mov ebx, [esp+12];
		call GetStringVar;
		push eax;
		
		call SetFakePerk;
fail:
		add esp, 32;
		pop esi;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) fSetFakeTrait() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		push esi;
		mov ecx, eax;
		call GetArgType;
		push eax;
		mov eax, ecx;
		call GetArg;
		push eax;
		mov eax, ecx;
		call GetArgType;
		push eax;
		mov eax, ecx;
		call GetArg;
		push eax;
		mov eax, ecx;
		call GetArgType;
		push eax;
		mov eax, ecx;
		call GetArg;
		push eax;
		mov eax, ecx;
		call GetArgType;
		push eax;
		mov eax, ecx;
		call GetArg;
		push eax;

		movzx eax, word ptr [esp+12];
		cmp eax, 0xc001;
		jne fail;
		movzx eax, word ptr [esp+20];
		cmp eax, 0xc001;
		jne fail;
		movzx eax, word ptr ds:[esp+4];
		cmp eax, 0x9001;
		je next1;
		cmp eax, 0x9801;
		jne fail;
next1:
		movzx eax, word ptr ds:[esp+28];
		cmp eax, 0x9001;
		je next2;
		cmp eax, 0x9801;
		jne fail;
next2:
		mov eax, ecx;
		mov edx, [esp+28];
		mov ebx, [esp+24];
		call GetStringVar;
		push eax;
		mov eax, [esp+20];
		push eax;
		mov eax, [esp+16];
		push eax;
		mov eax, ecx;
		mov edx, [esp+16];
		mov ebx, [esp+12];
		call GetStringVar;
		push eax;
		
		call SetFakeTrait;
fail:
		add esp, 32;
		pop esi;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) fSetPerkboxTitle() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		mov edi, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, edi;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0x9001;
		jz next;
		cmp dx, 0x9801;
		jnz end;
next:
		mov ebx, eax;
		mov eax, edi;
		mov ecx, GetStringVar;
		call ecx;
		push eax;
		call SetPerkboxTitle;
end:
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) fIgnoreDefaultPerks() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		call IgnoreDefaultPerks;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) fRestoreDefaultPerks() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		call RestoreDefaultPerks;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) fClearSelectablePerks() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		call ClearSelectablePerks;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) fHasFakePerk() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		mov edi, eax;
		call GetArgType;
		mov edx, eax;
		mov eax, edi;
		call GetArg;
		cmp dx, 0x9001;
		jz next;
		cmp dx, 0x9801;
		jnz end;
next:
		mov ebx, eax;
		mov eax, edi;
		mov ecx, GetStringVar;
		call ecx;
		push eax;
		call HasFakePerk;
end:
		mov edx, eax;
		mov eax, edi;
		call SetResult;
		mov eax, edi;
		mov edx, 0xc001;
		call SetResultType;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) fHasFakeTrait() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		mov edi, eax;
		call GetArgType;
		mov edx, eax;
		mov eax, edi;
		mov ebx, 0x467500;
		call GetArg;
		cmp dx, 0x9001;
		jz next;
		cmp dx, 0x9801;
		jnz end;
next:
		mov ebx, eax;
		mov eax, edi;
		mov ecx, GetStringVar;
		call ecx;
		push eax;
		call HasFakeTrait;
end:
		mov edx, eax;
		mov eax, edi;
		call SetResult;
		mov eax, edi;
		mov edx, 0xc001;
		call SetResultType;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) fAddPerkMode() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz end;
		push eax;
		call AddPerkMode;
end:
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
// memory_reading_funcs
static void __declspec(naked) ReadByte() {
	__asm {
		push ebx;
		push ecx;
		push edx;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz error;
		xor edx, edx;
		mov dl, byte ptr ds:[eax];
		jmp result;
error:
		mov edx, 0;
result:
		mov eax, ecx;
		mov ebx, 0x4674DC;
		call ebx;
		mov edx, 0xc001;
		mov eax, ecx;
		mov ebx, 0x46748C;
		call ebx;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}

static void __declspec(naked) ReadShort() {
	__asm {
		push ebx;
		push ecx;
		push edx;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz error;
		xor edx, edx;
		mov dx, word ptr ds:[eax];
		jmp result;
error:
		mov edx, 0;
result:
		mov eax, ecx;
		mov ebx, 0x4674DC;
		call ebx;
		mov edx, 0xc001;
		mov eax, ecx;
		mov ebx, 0x46748C;
		call ebx;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}

static void __declspec(naked) ReadInt() {
	__asm {
		push ebx;
		push ecx;
		push edx;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz error;
		xor edx, edx;
		mov edx, dword ptr ds:[eax];
		jmp result;
error:
		mov edx, 0;
result:
		mov eax, ecx;
		mov ebx, 0x4674DC;
		call ebx;
		mov edx, 0xc001;
		mov eax, ecx;
		mov ebx, 0x46748C;
		call ebx;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}

static void __declspec(naked) ReadString() {
	__asm {
		push ebx;
		push ecx;
		push edx;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz error;
		mov edx, eax;
		jmp result;
error:
		mov edx, 0;
result:
		mov eax, ecx;
		mov ebx, 0x4674DC;
		call ebx;
		mov edx, 0x9801;
		mov eax, ecx;
		mov ebx, 0x46748C;
		call ebx;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}

// stat_funcs
static void __declspec(naked) SetPCBaseStat() {
	_asm {
		//Store registers
		push ebx;
		push ecx;
		push edx;
		push edi;
		push esi;
		//Get function args
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov esi, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		mov edi, eax;
		mov eax, ecx;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		//eax now contains the stat ID, edi contains its new value
		//Check args are valid
		cmp dx, 0xC001;
		jnz end;
		cmp si, 0xC001;
		jnz end;
		test eax, eax;
		jl end;
		cmp eax, 0x23; //23, 24 and 25 are valid, but stored elsewhere. Ignore for now.
		jge end;
		//set the new value
		mov ds:[eax*4 + 0x51C394], edi;
end:
		//Restore registers and return
		pop esi;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) SetPCExtraStat() {
	_asm {
		//Store registers
		push ebx;
		push ecx;
		push edx;
		push edi;
		push esi;
		//Get function args
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov esi, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		mov edi, eax;
		mov eax, ecx;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		//eax now contains the stat ID, edi contains its new value
		//Check args are valid
		cmp dx, 0xC001;
		jnz end;
		cmp si, 0xC001;
		jnz end;
		test eax, eax;
		jl end;
		cmp eax, 0x23; //23, 24 and 25 are valid, but stored elsewhere. Ignore for now.
		jge end;
		//set the new value
		mov ds:[eax*4 + 0x51C420], edi;
end:
		//Restore registers and return
		pop esi;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) GetPCBaseStat() {
	_asm {
		//Store registers
		push ebx;
		push ecx;
		push edx;
		//Get function args
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		//Check arg is valid
		cmp dx, 0xC001;
		jnz fail;
		test eax, eax;
		jl fail;
		cmp eax, 0x23; //23, 24 and 25 are valid, but stored elsewhere. Ignore for now.
		jge fail;
		//set the new value
		mov edx, ds:[eax*4 + 0x51C394];
		jmp end;
fail:
		xor edx, edx;
end:
		//Pass back the result
		mov eax, ecx;
		mov ebx, 0x4674DC;
		call ebx;
		mov edx, 0xc001;
		mov eax, ecx;
		mov ebx, 0x46748C;
		call ebx;
		//Restore registers and return
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) GetPCExtraStat() {
	_asm {
		//Store registers
		push ebx;
		push ecx;
		push edx;
		//Get function args
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		//Check arg is valid
		cmp dx, 0xC001;
		jnz fail;
		test eax, eax;
		jl fail;
		cmp eax, 0x23; //23, 24 and 25 are valid, but stored elsewhere. Ignore for now.
		jge fail;
		//set the new value
		mov edx, ds:[eax*4 + 0x51C420];
		jmp end;
fail:
		xor edx, edx;
end:
		//Pass back the result
		mov eax, ecx;
		mov ebx, 0x4674DC;
		call ebx;
		mov edx, 0xc001;
		mov eax, ecx;
		mov ebx, 0x46748C;
		call ebx;
		//Restore registers and return
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) SetCritterBaseStat() {
	_asm {
		//Store registers
		push ebx;
		push ecx;
		push edx;
		push edi;
		push esi;
		//Get function args
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		push eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		mov edi, eax;
		mov eax, ecx;
		mov ebx, 0x4674F0;
		call ebx;
		push eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		mov esi, eax;
		mov eax, ecx;
		mov ebx, 0x4674F0;
		call ebx;
		push eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		//eax now contains the critter ID, esi the stat ID, and edi the new value
		//Check args are valid
		mov ebx, [esp];
		cmp bx, 0xC001;
		jnz end;
		mov ebx, [esp+4];
		cmp bx, 0xC001;
		jnz end;
		mov ebx, [esp+8];
		cmp bx, 0xC001;
		jnz end;
		test esi, esi;
		jl end;
		cmp esi, 0x23; //23, 24 and 25 are valid, but stored elsewhere. Ignore for now.
		jge end;
		//set the new value
		mov edx, esp;
		mov eax, [eax+0x64];
		mov ebx, 0x4A2108;
		call ebx;
		mov eax, [esp];
		add eax, 0x20;
		mov ds:[eax + esi*4 + 4], edi;
end:
		//Restore registers and return
		add esp, 12;
		pop esi;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) SetCritterExtraStat() {
	_asm {
		//Store registers
		push ebx;
		push ecx;
		push edx;
		push edi;
		push esi;
		//Get function args
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		push eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		mov edi, eax;
		mov eax, ecx;
		mov ebx, 0x4674F0;
		call ebx;
		push eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		mov esi, eax;
		mov eax, ecx;
		mov ebx, 0x4674F0;
		call ebx;
		push eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		//eax now contains the critter ID, esi the stat ID, and edi the new value
		//Check args are valid
		mov ebx, [esp];
		cmp bx, 0xC001;
		jnz end;
		mov ebx, [esp+4];
		cmp bx, 0xC001;
		jnz end;
		mov ebx, [esp+8];
		cmp bx, 0xC001;
		jnz end;
		test esi, esi;
		jl end;
		cmp esi, 0x23; //23, 24 and 25 are valid, but stored elsewhere. Ignore for now.
		jge end;
		//set the new value
		mov edx, esp;
		mov eax, [eax+0x64];
		mov ebx, 0x4A2108;
		call ebx;
		mov eax, [esp];
		add eax, 0x20;
		mov ds:[eax + esi*4 + 0x90], edi;
end:
		//Restore registers and return
		add esp, 12;
		pop esi;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) GetCritterBaseStat() {
	_asm {
		//Store registers
		push ebx;
		push ecx;
		push edx;
		push edi;
		//Get function args
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		push eax
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		mov edi, eax;
		mov eax, ecx;
		mov ebx, 0x4674F0;
		call ebx;
		push eax
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		//eax contains the critter pointer, and edi contains the stat id
		//Check args are valid
		mov ebx, [esp];
		cmp bx, 0xC001;
		jnz fail;
		mov ebx, [esp+4];
		cmp bx, 0xc001;
		jnz fail;
		test edi, edi;
		jl fail;
		cmp edi, 0x23; //23, 24 and 25 are valid, but stored elsewhere. Ignore for now.
		jge fail;
		//set the new value
		mov edx, esp;
		mov eax, [eax+0x64];
		mov ebx, 0x4A2108;
		call ebx;
		mov eax, [esp];
		add eax, 0x20;
		mov edx, ds:[eax + edi*4 + 4];
		jmp end;
fail:
		xor edx, edx;
end:
		//Pass back the result
		mov eax, ecx;
		mov ebx, 0x4674DC;
		call ebx;
		mov edx, 0xc001;
		mov eax, ecx;
		mov ebx, 0x46748C;
		call ebx;
		//Restore registers and return
		add esp, 8;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) GetCritterExtraStat() {
	_asm {
		//Store registers
		push ebx;
		push ecx;
		push edx;
		push edi;
		//Get function args
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		push eax
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		mov edi, eax;
		mov eax, ecx;
		mov ebx, 0x4674F0;
		call ebx;
		push eax
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		//eax contains the critter pointer, and edi contains the stat id
		//Check args are valid
		mov ebx, [esp];
		cmp bx, 0xC001;
		jnz fail;
		mov ebx, [esp+4];
		cmp bx, 0xc001;
		jnz fail;
		test edi, edi;
		jl fail;
		cmp edi, 0x23; //23, 24 and 25 are valid, but stored elsewhere. Ignore for now.
		jge fail;
		//set the new value
		mov edx, esp;
		mov eax, [eax+0x64];
		mov ebx, 0x4A2108;
		call ebx;
		mov eax, [esp];
		add eax, 0x20;
		mov edx, ds:[eax + edi*4 + 0x90];
		jmp end;
fail:
		xor edx, edx;
end:
		//Pass back the result
		mov eax, ecx;
		mov ebx, 0x4674DC;
		call ebx;
		mov edx, 0xc001;
		mov eax, ecx;
		mov ebx, 0x46748C;
		call ebx;
		//Restore registers and return
		add esp, 8;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) GetCritterAP() {
	_asm {
		//Store registers
		push ecx;
		push edx;
		push edi;
		//Get function args
		mov ecx, eax;
		call GetArgType;
		mov edi, eax;
		mov eax, ecx;
		call GetArg;
		//Check args are valid
		cmp di, 0xC001;
		jnz fail;
		mov edx, [eax+0x40];
		jmp end;
fail:
		xor edx, edx;
end:
		//Pass back the result
		mov eax, ecx;
		call SetResult;
		mov edx, 0xc001;
		mov eax, ecx;
		call SetResultType;
		//Restore registers and return
		pop edi;
		pop edx;
		pop ecx;
		retn;
	}
}
static void __declspec(naked) SetCritterAP() {
	_asm {
		//Store registers
		push ebx;
		push ecx;
		push edx;
		push edi;
		push esi;
		//Get function args
		mov ecx, eax;
		call GetArgType;
		mov edi, eax;
		mov eax, ecx;
		call GetArg;
		mov ebx, eax;
		mov eax, ecx;
		call GetArgType;
		mov esi, eax;
		mov eax, ecx;
		call GetArg;
		//Check args are valid
		cmp di, 0xC001;
		jnz end;
		cmp si, 0xC001;
		jnz end;
		mov [eax+0x40], ebx;
end:
		//Restore registers and return
		pop esi;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}

// input_functions
extern DWORD InputHookEnabled;
static void __declspec(naked) InputFuncsAvailable() {
	__asm {
		push ebx;
		push ecx;
		push edx;
		mov ecx, eax;
		mov edx, InputHookEnabled;
		mov ebx, 0x4674DC;
		call ebx;
		mov edx, 0xc001;
		mov eax, ecx;
		mov ebx, 0x46748C;
		call ebx;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) KeyPressed() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz fail;
		test eax, eax;
		jl fail;
		cmp eax, 255;
		jge fail;
		push ecx;
		push eax;
		call KeyDown;
		mov edx, eax;
		pop ecx;
		jmp end;
fail:
		xor edx, edx;
end:
		mov eax, ecx;
		mov ebx, 0x4674DC;
		call ebx;
		mov edx, 0xc001;
		mov eax, ecx;
		mov ebx, 0x46748C;
		call ebx;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) funcTapKey() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz end;
		test eax, eax;
		jl end;
		cmp eax, 255;
		jge end;
		push eax;
		call TapKey;
end:
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}

static void _stdcall strcpy_p(char* to, const char* from) {
	strcpy_s(to, 64, from);
}
static void __declspec(naked) SetDMModel() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		mov edi, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, edi;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0x9001;
		jz next;
		cmp dx, 0x9801;
		jnz end;
next:
		mov ebx, eax;
		mov eax, edi;
		mov ecx, 0x4678E0;
		call ecx;
		push eax;
		push dmModelNamePtr;
		call strcpy_p;
end:
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) SetDFModel() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		mov edi, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, edi;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0x9001;
		jz next;
		cmp dx, 0x9801;
		jnz end;
next:
		mov ebx, eax;
		mov eax, edi;
		mov ecx, 0x4678E0;
		call ecx;
		push eax;
		push dfModelNamePtr;
		call strcpy_p;
end:
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) SetMoviePath() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		push esi;
		mov edi, eax;
		mov ecx, 0x4674F0;
		call ecx;
		mov ebx, eax;
		mov eax, edi;
		mov ecx, 0x467500;
		call ecx;
		mov esi, eax;
		mov eax, edi;
		mov ecx, 0x4674F0;
		call ecx;
		mov edx, eax;
		mov eax, edi;
		mov ecx, 0x467500;
		call ecx;
		cmp dx, 0x9001;
		jz next;
		cmp dx, 0x9801;
		jnz end;
next:
		cmp bx, 0xc001;
		jnz end;
		cmp esi, 0;
		jl end;
		cmp esi, 17;
		jge end;
		mov ebx, eax;
		mov eax, edi;
		mov ecx, 0x4678E0;
		call ecx;
		push eax;
		mov eax, esi;
		mov esi, 65;
		mul si;
		add eax, MovieNamesPtr;
		push eax;
		call strcpy_p;
end:
		pop esi;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) GetYear() {
	__asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		mov edi, eax;
		sub esp, 4;
		xor eax, eax;
		xor edx, edx;
		mov ebx, esp;
		mov ecx, 0x004A3338;
		call ecx;
		mov edx, [esp];
		mov eax, AddUnarmedStatToGetYear;
		test eax, eax;
		jz end;
		add edx, ds:[0x51C3BC];
end:
		mov eax, edi;
		mov ebx, 0x4674DC;
		call ebx;
		mov edx, 0xc001;
		mov eax, edi;
		mov ebx, 0x46748C;
		call ebx;
		add esp, 4;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) GameLoaded() {
	__asm {
		push ebx;
		push ecx;
		push edx;
		push eax;
		push eax;
		call ScriptHasLoaded;
		mov edx, eax;
		pop eax;
		mov ecx, eax;
		mov ebx, 0x4674DC;
		call ebx;
		mov edx, 0xc001;
		mov eax, ecx;
		mov ebx, 0x46748C;
		call ebx;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void _stdcall SetGlobalScriptRepeat2(DWORD script, DWORD frames) {
	for(DWORD d=0;d<globalScripts.size();d++) {
		if(globalScripts[d].ptr==script) {
			if(frames==0xFFFFFFFF) globalScripts[d].mode=!globalScripts[d].mode;
			else globalScripts[d].repeat=frames;
			break;
		}
	}
}
static void __declspec(naked) SetGlobalScriptRepeat() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz end;
		push eax;
		push ecx;
		call SetGlobalScriptRepeat2;
end:
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void _stdcall SetGlobalScriptType2(DWORD script, DWORD type) {
	if(type>3) return;
	for(DWORD d=0;d<globalScripts.size();d++) {
		if(globalScripts[d].ptr==script) {
			globalScripts[d].mode=type;
			break;
		}
	}
}
static void __declspec(naked) SetGlobalScriptType() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz end;
		push eax;
		push ecx;
		call SetGlobalScriptType2;
end:
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) GetGlobalScriptTypes() {
	__asm {
		push ebx;
		push ecx;
		push edx;
		mov edx, AvailableGlobalScriptTypes;
		mov ecx, eax;
		mov ebx, 0x4674DC;
		call ebx;
		mov edx, 0xc001;
		mov eax, ecx;
		mov ebx, 0x46748C;
		call ebx;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void _stdcall SetGlobalVar2(char* var, int val) {
	if(strlen(var)!=8) return;
	__int64 var2 = *(__int64*)var;
	for(DWORD i=0;i<globalVars.size();i++) {
		if(globalVars[i].id==var2) {
			globalVars[i].val=val;
			return;
		}
	}
	if(globalVars.size()>=MaxGlobalVars) return;
	sGlobalVar sVar=sGlobalVar(var2, val);
	globalVars.push_back(sVar);
}
static void __declspec(naked) SetGlobalVar() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		push esi;
		mov edi, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov eax, edi;
		mov ebx, 0x467500;
		call ebx;
		mov esi, eax;
		mov eax, edi;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, edi;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0x9001;
		jz next;
		cmp dx, 0x9801;
		jnz end;
next:
		mov ebx, eax;
		mov eax, edi;
		mov ecx, 0x4678E0;
		call ecx;
		push esi;
		push eax;
		call SetGlobalVar2;
end:
		pop esi;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static DWORD _stdcall GetGlobalVar(char* var) {
	if(strlen(var)!=8) return 0;
	__int64 var2 = *(__int64*)var;
	for(DWORD i=0;i<globalVars.size();i++) {
		if(globalVars[i].id==var2) return globalVars[i].val;
	}
	return 0;
}
static void __declspec(naked) GetGlobalVarInt() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		push esi;
		xor edx, edx;
		mov edi, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov esi, eax;
		mov eax, edi;
		mov ebx, 0x467500;
		call ebx;
		cmp si, 0x9001;
		jz next;
		cmp si, 0x9801;
		jnz end;
next:
		mov edx, esi;
		mov ebx, eax;
		mov eax, edi;
		mov ecx, 0x4678E0;
		call ecx;
		push eax;
		call GetGlobalVar;
		mov edx, eax;
end:
		mov eax, edi;
		mov ebx, 0x4674DC;
		call ebx;
		mov edx, 0xc001;
		mov eax, edi;
		mov ebx, 0x46748C;
		call ebx;
		pop esi;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) GetGlobalVarFloat() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		push esi;
		xor edx, edx;
		mov edi, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov esi, eax;
		mov eax, edi;
		mov ebx, 0x467500;
		call ebx;
		cmp si, 0x9001;
		jz next;
		cmp si, 0x9801;
		jnz end;
next:
		mov edx, esi;
		mov ebx, eax;
		mov eax, edi;
		mov ecx, 0x4678E0;
		call ecx;
		push eax;
		call GetGlobalVar;
		mov edx, eax;
end:
		mov eax, edi;
		mov ebx, 0x4674DC;
		call ebx;
		mov edx, 0xa001;
		mov eax, edi;
		mov ebx, 0x46748C;
		call ebx;
		pop esi;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static DWORD EncounteredHorrigan;
static void _stdcall ForceEncounter4() {
	*(DWORD*)0x00672E04=EncounteredHorrigan;
	SafeWrite32(0x004C070E, 0x95);
	SafeWrite32(0x004C0718, 0x95);
	SafeWrite32(0x004C06D1, 0x2E043D83);
	SafeWrite32(0x004C071D, 0xFFFC2413);
}
static void __declspec(naked) ForceEncounter3() {
	_asm {
		push eax;
		push ebx;
		push ecx;
		push edx;
		mov eax, [esp+0x10];
		sub eax, 5;
		mov [esp+0x10], eax;
		call ForceEncounter4;
		pop edx;
		pop ecx;
		pop ebx;
		pop eax;
		retn;
	}
}
static void _stdcall ForceEncounter2(DWORD mapID) {
	EncounteredHorrigan=*(DWORD*)0x00672E04;
	SafeWrite32(0x004C070E, mapID);
	SafeWrite32(0x004C0718, mapID);
	SafeWrite32(0x004C06D1, 0x18EBD231); //xor edx, edx / jmp 0x18
	SafeWrite32(0x004C071D, ((DWORD)&ForceEncounter3) - 0x004C0721);
}
static void __declspec(naked) ForceEncounter() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz end;
		push eax;
		call ForceEncounter2;
end:
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) SetPipBoyAvailable() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz end;
		cmp eax, 0;
		jl end;
		cmp eax, 1;
		jg end;
		mov byte ptr ds:[0x00596C7B], al;
end:
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
// graphics_functions
static void __declspec(naked) GraphicsFuncsAvailable() {
	__asm {
		push ebx;
		push ecx;
		push edx;
		mov ecx, eax;
		xor edx, edx;
#ifndef WIN9X
		mov ebx, GraphicsMode;
		cmp ebx, 3;
		jle end;
		inc edx;
end:
#endif
		mov ebx, 0x4674DC;
		call ebx;
		mov edx, 0xc001;
		mov eax, ecx;
		mov ebx, 0x46748C;
		call ebx;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
#ifndef WIN9X
static void __declspec(naked) funcLoadShader() {
	__asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		mov edi, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, edi;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0x9001;
		jz next;
		cmp dx, 0x9801;
		jnz error;
next:
		mov ebx, eax;
		mov eax, edi;
		mov ecx, 0x4678E0;
		call ecx;
		push eax;
		call LoadShader;
		mov edx, eax;
		jmp result;
error:
		mov edx, -1;
result:
		mov eax, edi;
		mov ebx, 0x4674DC;
		call ebx;
		mov edx, 0xC001;
		mov eax, edi;
		mov ebx, 0x46748C;
		call ebx;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) funcFreeShader() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz end;
		push eax;
		call FreeShader;
end:
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) funcActivateShader() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz end;
		push eax;
		call ActivateShader;
end:
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) funcDeactivateShader() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz end;
		push eax;
		call DeactivateShader;
end:
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) funcGetShaderTexture() {
	_asm {
		//Store registers
		push ebx;
		push ecx;
		push edx;
		push edi;
		//Get function args
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		push eax
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		mov edi, eax;
		mov eax, ecx;
		mov ebx, 0x4674F0;
		call ebx;
		push eax
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		mov ebx, [esp];
		cmp bx, 0xC001;
		jnz fail;
		mov ebx, [esp+4];
		cmp bx, 0xc001;
		jnz fail;
		//set the new value
		push ecx;
		push edi;
		push eax;
		call GetShaderTexture;
		mov edx, eax;
		pop ecx;
		jmp end;
fail:
		mov edx, -1
end:
		//Pass back the result
		mov eax, ecx;
		mov ebx, 0x4674DC;
		call ebx;
		mov edx, 0xc001;
		mov eax, ecx;
		mov ebx, 0x46748C;
		call ebx;
		//Restore registers and return
		add esp, 8;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) funcSetShaderInt() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		push esi;
		push ebp;
		sub esp, 0xc;
		mov ecx, eax;
		//Get args
		mov ebx, 0x4674F0;
		call ebx;
		mov edi, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		mov [esp+8], eax;
		mov eax, ecx;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		mov ebp, eax;
		mov eax, ecx;
		mov ebx, 0x4674F0;
		call ebx;
		mov esi, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		mov [esp], eax;
		//Error check
		cmp di, 0xC001;
		jnz fail;
		cmp dx, 0x9001;
		jz next;
		cmp dx, 0x9801;
		jnz fail;
next:
		cmp si, 0xc001;
		jnz fail;
		mov eax, ecx;
		mov ebx, ebp;
		mov edi, 0x4678E0;
		call edi;
		mov [esp+4], eax;
		call SetShaderInt;
		jmp end;
fail:
		add esp, 0xc;
end:
		pop ebp;
		pop esi;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) funcSetShaderTexture() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		push esi;
		push ebp;
		sub esp, 0xc;
		mov ecx, eax;
		//Get args
		mov ebx, 0x4674F0;
		call ebx;
		mov edi, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		mov [esp+8], eax;
		mov eax, ecx;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		mov ebp, eax;
		mov eax, ecx;
		mov ebx, 0x4674F0;
		call ebx;
		mov esi, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		mov [esp], eax;
		//Error check
		cmp di, 0xC001;
		jnz fail;
		cmp dx, 0x9001;
		jz next;
		cmp dx, 0x9801;
		jnz fail;
next:
		cmp si, 0xc001;
		jnz fail;
		mov eax, ecx;
		mov ebx, ebp;
		mov edi, 0x4678E0;
		call edi;
		mov [esp+4], eax;
		call SetShaderTexture;
		jmp end;
fail:
		add esp, 0xc;
end:
		pop ebp;
		pop esi;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) funcSetShaderFloat() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		push esi;
		push ebp;
		sub esp, 0xc;
		mov ecx, eax;
		//Get args
		mov ebx, 0x4674F0;
		call ebx;
		mov edi, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		mov [esp+8], eax;
		mov eax, ecx;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		mov ebp, eax;
		mov eax, ecx;
		mov ebx, 0x4674F0;
		call ebx;
		mov esi, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		mov [esp], eax;
		//Error check
		cmp di, 0xa001;
		jz paramWasFloat;
		cmp di, 0xc001;
		jnz fail;
		fild [esp+8];
		fstp [esp+8];
paramWasFloat:
		cmp dx, 0x9001;
		jz next;
		cmp dx, 0x9801;
		jnz fail;
next:
		cmp si, 0xc001;
		jnz fail;
		mov eax, ecx;
		mov ebx, ebp;
		mov edi, 0x4678E0;
		call edi;
		mov [esp+4], eax;
		call SetShaderFloat;
		jmp end;
fail:
		add esp, 0xc;
end:
		pop ebp;
		pop esi;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) funcSetShaderVector() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push ebp;
		sub esp, 0x2a;
		mov ebp, eax;
		//Get args
		mov ecx, 6;
argloopstart:
		mov eax, ebp;
		mov ebx, 0x4674F0;
		call ebx;
		mov word ptr [esp+ecx*2+0x16], ax;
		mov eax, ebp;
		mov ebx, 0x467500;
		call ebx;
		mov [esp+ecx*4-0x4], eax;
		loop argloopstart;
		//Error check
		mov ecx, 4;
checkloopstart:
		cmp word ptr [esp+ecx*2+0x1a], 0xa001;
		jz paramWasFloat;
		cmp word ptr [esp+ecx*2+0x1a], 0xc001;
		jnz fail;
		fild [esp+ecx*4+0x4];
		fstp [esp+ecx*4+0x4];
paramWasFloat:
		loop checkloopstart;
		cmp word ptr [esp+0x1a], 0x9001;
		jz next;
		cmp word ptr [esp+0x1a], 0x9801;
		jnz fail;
next:
		cmp word ptr [esp+0x18], 0xc001;
		jnz fail;
		mov eax, ebp;
		mov ebx, [esp+4];
		xor edx, edx;
		mov dx, word ptr [esp+0x1a];
		mov edi, 0x4678E0;
		call edi;
		mov [esp+4], eax;
		call SetShaderVector;
		add esp, 0x12;
		jmp end;
fail:
		add esp, 0x2a;
end:
		pop ebp;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) funcGetShaderVersion() {
	__asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		mov edi, eax;
		call GetShaderVersion;
		mov edx, eax;
		mov eax, edi;
		mov ebx, 0x4674DC;
		call ebx;
		mov edx, 0xc001;
		mov eax, edi;
		mov ebx, 0x46748C;
		call ebx;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) funcSetShaderMode() {
	__asm {
		push ebx;
		push ecx;
		push edx;
		push esi;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		push eax;
		mov eax, ecx;
		mov ebx, 0x4674F0;
		call ebx;
		mov esi, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz fail;
		cmp si, 0xC001;
		jnz fail;
		push eax;
		call SetShaderMode;
		jmp end
fail:
		pop eax;
end:
		pop esi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) funcForceGraphicsRefresh() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz end;
		push eax;
		call ForceGraphicsRefresh;
end:
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
#endif
// world_map_functions
static void __declspec(naked) funcInWorldMap() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		mov ecx, eax;
		call InWorldMap;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x4674DC;
		call ebx;
		mov edx, 0xc001;
		mov eax, ecx;
		mov ebx, 0x46748C;
		call ebx;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) GetGameMode() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		mov ecx, eax;
		call GetCurrentLoops;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x4674DC;
		call ebx;
		mov edx, 0xc001;
		mov eax, ecx;
		mov ebx, 0x46748C;
		call ebx;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) GetWorldMapXPos() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		mov ecx, eax;
		mov edx, ds:[0x00672E0C];
		mov ebx, 0x4674DC;
		call ebx;
		mov edx, 0xc001;
		mov eax, ecx;
		mov ebx, 0x46748C;
		call ebx;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) GetWorldMapYPos() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		mov ecx, eax;
		mov edx, ds:[0x00672E10];
		mov ebx, 0x4674DC;
		call ebx;
		mov edx, 0xc001;
		mov eax, ecx;
		mov ebx, 0x46748C;
		call ebx;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) SetWorldMapPos() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		push esi;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov esi, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		mov edi, eax;
		mov eax, ecx;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz end;
		cmp si, 0xC001;
		jnz end;
		mov ds:[0x00672E0C], eax;
		mov ds:[0x00672E10], edi;
end:
		pop esi;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}

// Kill counters
static void __declspec(naked) GetKillCounter() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz fail;
		cmp eax, 19;
		jge fail;
		mov edx, ds:[0x0056D780+eax*4];
		jmp end;
fail:
		
		xor edx, edx;
end:
		mov eax, ecx
		mov ebx, 0x4674DC;
		call ebx;
		mov edx, 0xc001;
		mov eax, ecx;
		mov ebx, 0x46748C;
		call ebx;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) ModKillCounter() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		push esi;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov esi, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		mov edi, eax;
		mov eax, ecx;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz end;
		cmp si, 0xC001;
		jnz end;
		cmp eax, 19;
		jge end;
		add ds:[0x0056D780+eax*4], edi;
end:
		pop esi;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
//Knockback
static void __declspec(naked) SetKnockback() {
	_asm {
		sub esp, 0xc;
		mov ecx, eax;
		//Get args
		mov ebx, 0x4674F0;
		call ebx;	//First arg type
		mov edi, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;	//First arg
		mov [esp+8], eax;
		mov eax, ecx;
		mov ebx, 0x4674F0;
		call ebx;	//Second arg type
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;	//Second arg
		mov [esp+4], eax;
		mov eax, ecx;
		mov ebx, 0x4674F0;
		call ebx;	//Third arg type
		mov esi, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;	//Third arg
		mov [esp], eax;
		//Error check
		cmp di, 0xa001;
		jz paramWasFloat;
		cmp di, 0xc001;
		jnz fail;
		fild [esp+8];
		fstp [esp+8];
paramWasFloat:
		cmp dx, 0xc001;
		jnz fail;
		cmp si, 0xc001;
		jnz fail;
		call KnockbackSetMod;
		jmp end;
fail:
		add esp, 0x10;
end:
		popad;
		retn;
	}
}
static void __declspec(naked) SetWeaponKnockback() {
	_asm {
		pushad;
		push 0;
		jmp SetKnockback;
	}
}
static void __declspec(naked) SetTargetKnockback() {
	_asm {
		pushad;
		push 1;
		jmp SetKnockback;
	}
}
static void __declspec(naked) SetAttackerKnockback() {
	_asm {
		pushad;
		push 2;
		jmp SetKnockback;
	}
}
static void __declspec(naked) RemoveKnockback() {
	_asm {
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz fail;
		push eax;
		call KnockbackRemoveMod;
		jmp end;
fail:
		add esp, 4;
end:
		popad;
		retn;
	}
}
static void __declspec(naked) RemoveWeaponKnockback() {
	_asm {
		pushad;
		push 0;
		jmp RemoveKnockback;
	}
}
static void __declspec(naked) RemoveTargetKnockback() {
	_asm {
		pushad;
		push 1;
		jmp RemoveKnockback;
	}
}
static void __declspec(naked) RemoveAttackerKnockback() {
	_asm {
		pushad;
		push 2;
		jmp RemoveKnockback;
	}
}
//static const char* testTxt = "bingle";
static void __declspec(naked) GetKillCounter2() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz fail;
		cmp eax, 38;
		jge fail;
		mov edx, ds:[0x0056D780+eax*2];
		jmp end;
fail:
		xor edx, edx;
end:
		mov eax, ecx
		mov ebx, 0x4674DC;
		call ebx;
		mov edx, 0xc001;
		mov eax, ecx;
		mov ebx, 0x46748C;
		call ebx;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) ModKillCounter2() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		push esi;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov esi, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		mov edi, eax;
		mov eax, ecx;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz end;
		cmp si, 0xC001;
		jnz end;
		cmp eax, 38;
		jge end;
		add ds:[0x0056D780+eax*2], edi;
end:
		pop esi;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}

static void __declspec(naked) GetActiveHand() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		mov ecx, eax;
		mov edx, [0x00518F78];
		mov ebx, 0x4674DC;
		call ebx;
		mov edx, 0xc001;
		mov eax, ecx;
		mov ebx, 0x46748C;
		call ebx;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) ToggleActiveHand() {
	_asm {
		push ebx;
		mov eax, 1;
		mov ebx, 0x0045F404;
		call ebx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) fSetPickpocketMax() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz end;
		and eax, 0xff;
		cmp eax, 100;
		jg end;
		push eax;
		push eax;
		push 0;
		push eax;
		push 0xffffffff;
		call SetPickpocketMax;
end:
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) fSetHitChanceMax() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz end;
		and eax, 0xff;
		cmp eax, 100;
		jg end;
		push 0;
		push eax;
		push 0xffffffff;
		call SetHitChanceMax;
end:
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) SetCritterHitChance() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		mov edi, eax;
		xor ebx, ebx
		call GetArgType;
		cmp ax, 0xc001;
		cmovne ebx, edi;
		mov eax, edi;
		call GetArg;
		mov ecx, eax;
		mov eax, edi;
		call GetArgType;
		cmp ax, 0xc001;
		cmovne ebx, edi;
		mov eax, edi;
		call GetArg;
		mov edx, eax;
		mov eax, edi;
		call GetArgType;
		cmp ax, 0xc001;
		cmovne ebx, edi;
		mov eax, edi;
		call GetArg;
		test ebx, ebx;
		jnz end;
		push ecx;
		push edx;
		push eax;
		call SetHitChanceMax;
end:
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) SetBaseHitChance() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		mov edi, eax;
		xor ebx, ebx
		call GetArgType;
		cmp ax, 0xc001;
		cmovne ebx, edi;
		mov eax, edi;
		call GetArg;
		mov ecx, eax;
		mov eax, edi;
		call GetArgType;
		cmp ax, 0xc001;
		cmovne ebx, edi;
		mov eax, edi;
		call GetArg;
		test ebx, ebx;
		jnz end;
		push ecx;
		push eax;
		push 0xffffffff;
		call SetHitChanceMax;
end:
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) SetCritterPickpocket() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		mov edi, eax;
		xor ebx, ebx
		call GetArgType;
		cmp ax, 0xc001;
		cmovne ebx, edi;
		mov eax, edi;
		call GetArg;
		mov ecx, eax;
		mov eax, edi;
		call GetArgType;
		cmp ax, 0xc001;
		cmovne ebx, edi;
		mov eax, edi;
		call GetArg;
		mov edx, eax;
		mov eax, edi;
		call GetArgType;
		cmp ax, 0xc001;
		cmovne ebx, edi;
		mov eax, edi;
		call GetArg;
		test ebx, ebx;
		jnz end;
		push ecx;
		push edx;
		push eax;
		call SetPickpocketMax;
end:
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) SetBasePickpocket() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		mov edi, eax;
		xor ebx, ebx
		call GetArgType;
		cmp ax, 0xc001;
		cmovne ebx, edi;
		mov eax, edi;
		call GetArg;
		mov ecx, eax;
		mov eax, edi;
		call GetArgType;
		cmp ax, 0xc001;
		cmovne ebx, edi;
		mov eax, edi;
		call GetArg;
		test ebx, ebx;
		jnz end;
		push ecx;
		push eax;
		push 0xffffffff;
		call SetPickpocketMax;
end:
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) SetCritterSkillMod() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		mov edi, eax;
		xor ebx, ebx
		call GetArgType;
		cmp ax, 0xc001;
		cmovne ebx, edi;
		mov eax, edi;
		call GetArg;
		mov ecx, eax;
		mov eax, edi;
		call GetArgType;
		cmp ax, 0xc001;
		cmovne ebx, edi;
		mov eax, edi;
		call GetArg;
		test ebx, ebx;
		jnz end;
		push ecx;
		push eax;
		call SetSkillMax;
end:
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) SetBaseSkillMod() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		mov edi, eax;
		xor ebx, ebx
		call GetArgType;
		cmp ax, 0xc001;
		cmovne ebx, edi;
		mov eax, edi;
		call GetArg;
		mov ecx, eax;
		test ebx, ebx;
		jnz end;
		push eax;
		push 0xffffffff;
		call SetSkillMax;
end:
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) fSetSkillMax() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz end;
		and eax, 0xffff;
		cmp eax, 300;
		jg end;
		push 0;
		push eax;
		push 0xffffffff;
		call SetSkillMax;
end:
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) SetStatMax() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		push esi;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov esi, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		mov edi, eax;
		mov eax, ecx;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz end;
		cmp si, 0xC001;
		jnz end;
		push edi;
		push eax;
		push edi;
		push eax;
		call SetPCStatMax;
		call SetNPCStatMax;
end:
		pop esi;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) SetStatMin() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		push esi;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov esi, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		mov edi, eax;
		mov eax, ecx;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz end;
		cmp si, 0xC001;
		jnz end;
		push edi;
		push eax;
		push edi;
		push eax;
		call SetPCStatMax;
		call SetNPCStatMax;
end:
		pop esi;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) fSetPCStatMax() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		push esi;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov esi, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		mov edi, eax;
		mov eax, ecx;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz end;
		cmp si, 0xC001;
		jnz end;
		push edi;
		push eax;
		call SetPCStatMax;
end:
		pop esi;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) fSetPCStatMin() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		push esi;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov esi, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		mov edi, eax;
		mov eax, ecx;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz end;
		cmp si, 0xC001;
		jnz end;
		push edi;
		push eax;
		call SetPCStatMax;
end:
		pop esi;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) fSetNPCStatMax() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		push esi;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov esi, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		mov edi, eax;
		mov eax, ecx;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz end;
		cmp si, 0xC001;
		jnz end;
		push edi;
		push eax;
		call SetNPCStatMax;
end:
		pop esi;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) fSetNPCStatMin() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		push esi;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov esi, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		mov edi, eax;
		mov eax, ecx;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz end;
		cmp si, 0xC001;
		jnz end;
		push edi;
		push eax;
		call SetNPCStatMax;
end:
		pop esi;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static float xpmod;
static DWORD xptmp;
static void __declspec(naked) SetXpMod3() {
	_asm {
		push ebx;
		push ecx;
		push esi;
		push edi;
		push ebp;
		mov xptmp, eax;
		fild xptmp;
		fmul xpmod;
		fistp xptmp;
		mov eax, xptmp;
		mov ebx, 0x004AFABD;
		jmp ebx;
	}
}
static void _stdcall SetXpMod2(DWORD percent) {
	SafeWrite8(0x004AFAB8, 0xe9);
	SafeWrite32(0x004AFAB9, (DWORD)&SetXpMod3 - 0x004AFABD);
	xpmod=(float)percent/100.0f;
}
static void __declspec(naked) SetXpMod() {
	__asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz end;
		and eax, 0xffff;
		push eax;
		call SetXpMod2;
end:
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static int PerkLevelMod;
static void __declspec(naked) SetPerkLevelMod3() {
	__asm {
		push ebx;
		mov ebx, 0x004AF8FC;
		call ebx;
		pop ebx;
		add eax, PerkLevelMod;
		cmp eax, 0;
		jge end;
		xor eax, eax;
end:
		retn;
	}
}
static void _stdcall SetPerkLevelMod2(int mod) {
	if(mod<-25||mod>25) return;
	PerkLevelMod=mod;
	SafeWrite32(0x00496880, (DWORD)&SetPerkLevelMod3 - 0x00496884);
}
static void __declspec(naked) SetPerkLevelMod() {
	__asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz end;
		push eax;
		call SetPerkLevelMod2;
end:
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) EaxAvailable() {
	__asm {
		push ebx;
		push eax;
		push edx;
		push edi;
		mov edi, eax;
#ifdef WIN9X
		xor edx, edx
#else
		call IsEAXAvailable;
		mov edx, eax;
		mov eax, edi;
#endif
		mov ebx, 0x4674DC;
		call ebx;
		mov edx, 0xc001;
		mov eax, edi;
		mov ebx, 0x46748C;
		call ebx;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
#ifndef WIN9X
static void __declspec(naked) SetEaxEnvironmentFunc() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz end;
		push eax;
		call SetEAXEnvironment;
end:
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
#endif
static char* NPCToInc;
static void _stdcall IncNPCLevel4(char* npc) {
	if(strcmp(npc, NPCToInc)) {
		SafeWrite8(0x00495C50, 0xe9);
		SafeWrite32(0x00495C51, 0x000001fc);
	} else {
		SafeWrite16(0x00495C50, 0x840f);	//Want to keep this check intact.
		SafeWrite32(0x00495C52, 0x000001fb);

		//SafeWrite16(0x00495C50, 0x9090);
		//SafeWrite32(0x00495C52, 0x90909090);
		SafeWrite16(0x00495C77, 0x9090);	//Check that the player is high enough for the npc to consider this level
		SafeWrite32(0x00495C79, 0x90909090);
		//SafeWrite16(0x00495C8C, 0x9090);	//Check that the npc isn't already at its maximum level
		//SafeWrite32(0x00495C8E, 0x90909090);
		SafeWrite16(0x00495CEC, 0x9090);	//Check that the npc hasn't already levelled up recently
		SafeWrite32(0x00495CEE, 0x90909090);
		if(!npcautolevel) {
			SafeWrite16(0x00495D22, 0x9090);//Random element
			SafeWrite32(0x00495D24, 0x90909090);
		}
	}
}
static void __declspec(naked) IncNPCLevel3() {
	_asm {
		pushad;
		push eax;
		call IncNPCLevel4;
		popad;
		mov eax, 0x00495BF9;
		jmp eax;
	}
}
static void _stdcall IncNPCLevel2(char* npc) {
	NPCToInc=npc;
	SafeWrite8(0x00495BEB, 0xe9);	//Replace the debug output with a jmp
	SafeWrite32(0x00495BEC, ((DWORD)&IncNPCLevel3) - 0x00495BF0);
	_asm {
		mov eax, 0x00495B60;
		call eax;
	}
	SafeWrite16(0x00495C50, 0x840f);
	SafeWrite32(0x00495C52, 0x000001fb);
	SafeWrite16(0x00495C77, 0x8c0f);
	SafeWrite32(0x00495C79, 0x000001d4);
	//SafeWrite16(0x00495C8C, 0x8d0f);
	//SafeWrite32(0x00495C8E, 0x000001bf);
	SafeWrite16(0x00495CEC, 0x850f);
	SafeWrite32(0x00495CEE, 0x00000130);
	if(!npcautolevel) {
		SafeWrite16(0x00495D22, 0x8f0f);
		SafeWrite32(0x00495D24, 0x00000129);
	}
}
static void __declspec(naked) IncNPCLevel() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		mov edi, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, edi;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0x9001;
		jz next;
		cmp dx, 0x9801;
		jnz end;
next:
		mov ebx, eax;
		mov eax, edi;
		mov ecx, GetStringVar;
		call ecx;
		push eax;
		call IncNPCLevel2;
end:
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) GetViewportX() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		mov ecx, eax;
		mov edx, ds:[0x51DE2C];
		mov ebx, 0x4674DC;
		call ebx;
		mov edx, 0xc001;
		mov eax, ecx;
		mov ebx, 0x46748C;
		call ebx;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) GetViewportY() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		mov ecx, eax;
		mov edx, ds:[0x51DE30];
		mov ebx, 0x4674DC;
		call ebx;
		mov edx, 0xc001;
		mov eax, ecx;
		mov ebx, 0x46748C;
		call ebx;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) SetViewportX() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz end;
		mov ds:[0x51DE2C], eax
end:
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) SetViewportY() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz end;
		mov ds:[0x51DE30], eax
end:
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static int _stdcall GetIniSetting2(const char* c) {
	const char* key=strstr(c, "|");
	if(!key) return -1;
	DWORD filelen=(DWORD)key - (DWORD)c;
	if(filelen>=16) return -1;
	key=strstr(key+1, "|");
	if(!key) return -1;
	DWORD seclen=(DWORD)key - ((DWORD)c + filelen + 1);
	if(seclen>8) return -1;

	char file[18];
	file[0]='.';
	file[1]='\\';
	memcpy(&file[2], c, filelen);
	//for(DWORD i=0;i<filelen;i++) file[i+2]=c[i];
	file[filelen+2]=0;

	char section[9];
	memcpy(section, &c[filelen+1], seclen);
	//for(DWORD i=0;i<seclen;i++) section[i]=c[i+filelen+1];
	section[seclen]=0;

	key++;
	return GetPrivateProfileInt(section, key, -1, file);
}
static void __declspec(naked) GetIniSetting() {
	__asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		mov edi, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, edi;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0x9001;
		jz next;
		cmp dx, 0x9801;
		jnz error;
next:
		mov ebx, eax;
		mov eax, edi;
		mov ecx, 0x4678E0;
		call ecx;
		push eax;
		call GetIniSetting2;
		mov edx, eax;
		jmp result;
error:
		mov edx, -1;
result:
		mov eax, edi;
		mov ebx, 0x4674DC;
		call ebx;
		mov edx, 0xC001;
		mov eax, edi;
		mov ebx, 0x46748C;
		call ebx;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) funcGetTickCount() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		mov edi, eax;
		call GetTickCount;
		mov edx, eax;
		mov eax, edi;
		mov ebx, 0x4674DC;
		call ebx;
		mov edx, 0xc001;
		mov eax, edi;
		mov ebx, 0x46748C;
		call ebx;
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) SetCarTown() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		push edi;
		mov ecx, eax;
		mov ebx, 0x4674F0;
		call ebx;
		mov edx, eax;
		mov eax, ecx;
		mov ebx, 0x467500;
		call ebx;
		cmp dx, 0xC001;
		jnz end;
		mov ds:[0x00672E68], eax;
end:
		pop edi;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) SetPyromaniacMod() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		mov ecx, eax;
		call GetArgType;
		mov edx, eax;
		mov eax, ecx;
		call GetArg;
		cmp dx, 0xC001;
		jnz end;
		push eax;
		push 0x424AB6;
		call SafeWrite8;
end:
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) fApplyHeaveHoFix() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		call ApplyHeaveHoFix;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) SetSwiftLearnerMod() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		mov ecx, eax;
		call GetArgType;
		mov edx, eax;
		mov eax, ecx;
		call GetArg;
		cmp dx, 0xC001;
		jnz end;
		push eax;
		push 0x4AFAE2;
		call SafeWrite32;
end:
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
//END OF SCRIPT FUNCTIONS
static void __declspec(naked) MainGameLoopHook() {
	_asm {
		push ebx;
		push ecx;
		push edx;
		mov ebx, 0x004C8B78;
		call ebx;
		push eax;
		call RunGlobalScripts1;
		pop eax;
		pop edx;
		pop ecx;
		pop ebx;
		retn;
	}
}
static void __declspec(naked) CombatLoopHook() {
	_asm {
		pushad;
		call RunGlobalScripts1;
		popad;
		mov ebx, 0x004C8B78;
		jmp ebx;
	}
}
static bool Setup=false;
void ScriptExtenderSetup() {
#ifdef WIN9X
	checkedScripts=vector<DWORD>();
	globalScripts=vector<sGlobalScript>();
	globalVars=vector<sGlobalVar>();
#endif
	StatsInit();
	SafeWrite32(0x0046E370, 0x200);	//Maximum number of allowed opcodes
	SafeWrite32(0x46ce34, (DWORD)opcodes);	//cmp check to make sure opcode exists
	SafeWrite32(0x46ce6c, (DWORD)opcodes);	//call that actually jumps to the opcode
	SafeWrite32(0x46e390, (DWORD)opcodes);	//mov that writes to the opcode

	SafeWrite32(0x00480E7C, ((DWORD)&MainGameLoopHook) - 0x00480E80); //hook the main game loop
	SafeWrite32(0x00422846, (DWORD)&CombatLoopHook - 0x0042284a); //hook the combat loop

	opcodes[0x156]=(DWORD)&ReadByte;
	opcodes[0x157]=(DWORD)&ReadShort;
	opcodes[0x158]=(DWORD)&ReadInt;
	opcodes[0x159]=(DWORD)&ReadString;
	opcodes[0x15a]=(DWORD)&SetPCBaseStat;
	opcodes[0x15b]=(DWORD)&SetPCExtraStat;
	opcodes[0x15c]=(DWORD)&GetPCBaseStat;
	opcodes[0x15d]=(DWORD)&GetPCExtraStat;
	opcodes[0x15e]=(DWORD)&SetCritterBaseStat;
	opcodes[0x15f]=(DWORD)&SetCritterExtraStat;
	opcodes[0x160]=(DWORD)&GetCritterBaseStat;
	opcodes[0x161]=(DWORD)&GetCritterExtraStat;
	opcodes[0x162]=(DWORD)&funcTapKey;
	opcodes[0x163]=(DWORD)&GetYear;
	opcodes[0x164]=(DWORD)&GameLoaded;
	opcodes[0x165]=(DWORD)&GraphicsFuncsAvailable;
#ifndef WIN9X
	opcodes[0x166]=(DWORD)&funcLoadShader;
	opcodes[0x167]=(DWORD)&funcFreeShader;
	opcodes[0x168]=(DWORD)&funcActivateShader;
	opcodes[0x169]=(DWORD)&funcDeactivateShader;
#endif
	opcodes[0x16a]=(DWORD)&SetGlobalScriptRepeat;
	opcodes[0x16b]=(DWORD)&InputFuncsAvailable;
	opcodes[0x16c]=(DWORD)&KeyPressed;
#ifndef WIN9X
	opcodes[0x16d]=(DWORD)&funcSetShaderInt;
	opcodes[0x16e]=(DWORD)&funcSetShaderFloat;
	opcodes[0x16f]=(DWORD)&funcSetShaderVector;
#endif
	opcodes[0x170]=(DWORD)&funcInWorldMap;
	opcodes[0x171]=(DWORD)&ForceEncounter;
	opcodes[0x172]=(DWORD)&SetWorldMapPos;
	opcodes[0x173]=(DWORD)&GetWorldMapXPos;
	opcodes[0x174]=(DWORD)&GetWorldMapYPos;
	opcodes[0x175]=(DWORD)&SetDMModel;
	opcodes[0x176]=(DWORD)&SetDFModel;
	opcodes[0x177]=(DWORD)&SetMoviePath;
	opcodes[0x178]=(DWORD)&SetPerkValue1;
	opcodes[0x179]=(DWORD)&SetPerkValue2;
	opcodes[0x17a]=(DWORD)&SetPerkValue3;
	opcodes[0x17b]=(DWORD)&SetPerkValue4;
	opcodes[0x17c]=(DWORD)&SetPerkValue5;
	opcodes[0x17d]=(DWORD)&SetPerkValue6;
	opcodes[0x17e]=(DWORD)&SetPerkValue7;
	opcodes[0x17f]=(DWORD)&SetPerkValue8;
	opcodes[0x180]=(DWORD)&SetPerkValue9;
	opcodes[0x181]=(DWORD)&SetPerkValue10;
	opcodes[0x182]=(DWORD)&SetPerkValue11;
	opcodes[0x183]=(DWORD)&SetPerkValue12;
	opcodes[0x184]=(DWORD)&SetPerkValue13;
	opcodes[0x185]=(DWORD)&SetPerkValue14;
	opcodes[0x186]=(DWORD)&SetPerkValue15;
	opcodes[0x187]=(DWORD)&SetPerkValue16;
	opcodes[0x188]=(DWORD)&SetPerkValue17;
	opcodes[0x189]=(DWORD)&funcSetPerkName;
	opcodes[0x18a]=(DWORD)&funcSetPerkDesc;
	opcodes[0x18b]=(DWORD)&SetPipBoyAvailable;
	if(UsingExtraKillTypes()) {
		opcodes[0x18c]=(DWORD)&GetKillCounter2;
		opcodes[0x18d]=(DWORD)&ModKillCounter2;
	} else {
		opcodes[0x18c]=(DWORD)&GetKillCounter;
		opcodes[0x18d]=(DWORD)&ModKillCounter;
	}
	opcodes[0x18e]=(DWORD)&GetPerkOwed;
	opcodes[0x18f]=(DWORD)&SetPerkOwed;
	opcodes[0x190]=(DWORD)&GetPerkAvailable;
	opcodes[0x191]=(DWORD)&GetCritterAP;
	opcodes[0x192]=(DWORD)&SetCritterAP;
	opcodes[0x193]=(DWORD)&GetActiveHand;
	opcodes[0x194]=(DWORD)&ToggleActiveHand;
	opcodes[0x195]=(DWORD)&SetWeaponKnockback;
	opcodes[0x196]=(DWORD)&SetTargetKnockback;
	opcodes[0x197]=(DWORD)&SetAttackerKnockback;
	opcodes[0x198]=(DWORD)&RemoveWeaponKnockback;
	opcodes[0x199]=(DWORD)&RemoveTargetKnockback;
	opcodes[0x19a]=(DWORD)&RemoveAttackerKnockback;
	opcodes[0x19b]=(DWORD)&SetGlobalScriptType;
	opcodes[0x19c]=(DWORD)&GetGlobalScriptTypes;
	opcodes[0x19d]=(DWORD)&SetGlobalVar;
	opcodes[0x19e]=(DWORD)&GetGlobalVarInt;
	opcodes[0x19f]=(DWORD)&GetGlobalVarFloat;
	opcodes[0x1a0]=(DWORD)&fSetPickpocketMax;
	opcodes[0x1a1]=(DWORD)&fSetHitChanceMax;
	opcodes[0x1a2]=(DWORD)&fSetSkillMax;
	opcodes[0x1a3]=(DWORD)&EaxAvailable;
#ifndef WIN9X
	opcodes[0x1a4]=(DWORD)&SetEaxEnvironmentFunc;
#endif
	opcodes[0x1a5]=(DWORD)&IncNPCLevel;
	opcodes[0x1a6]=(DWORD)&GetViewportX;
	opcodes[0x1a7]=(DWORD)&GetViewportY;
	opcodes[0x1a8]=(DWORD)&SetViewportX;
	opcodes[0x1a9]=(DWORD)&SetViewportY;
	opcodes[0x1aa]=(DWORD)&SetXpMod;
	opcodes[0x1ab]=(DWORD)&SetPerkLevelMod;
	opcodes[0x1ac]=(DWORD)&GetIniSetting;
#ifndef WIN9X
	opcodes[0x1ad]=(DWORD)&funcGetShaderVersion;
	opcodes[0x1ae]=(DWORD)&funcSetShaderMode;
#endif
	opcodes[0x1af]=(DWORD)&GetGameMode;
#ifndef WIN9X
	opcodes[0x1b0]=(DWORD)&funcForceGraphicsRefresh;
	opcodes[0x1b1]=(DWORD)&funcGetShaderTexture;
	opcodes[0x1b2]=(DWORD)&funcSetShaderTexture;
#endif
	opcodes[0x1b3]=(DWORD)&funcGetTickCount;
	opcodes[0x1b4]=(DWORD)&SetStatMax;
	opcodes[0x1b5]=(DWORD)&SetStatMin;
	opcodes[0x1b6]=(DWORD)&SetCarTown;
	opcodes[0x1b7]=(DWORD)&fSetPCStatMax;
	opcodes[0x1b8]=(DWORD)&fSetPCStatMin;
	opcodes[0x1b9]=(DWORD)&fSetNPCStatMax;
	opcodes[0x1ba]=(DWORD)&fSetNPCStatMin;
	opcodes[0x1bb]=(DWORD)&fSetFakePerk;
	opcodes[0x1bc]=(DWORD)&fSetFakeTrait;
	opcodes[0x1bd]=(DWORD)&fSetSelectablePerk;
	opcodes[0x1be]=(DWORD)&fSetPerkboxTitle;
	opcodes[0x1bf]=(DWORD)&fIgnoreDefaultPerks;
	opcodes[0x1c0]=(DWORD)&fRestoreDefaultPerks;
	opcodes[0x1c1]=(DWORD)&fHasFakePerk;
	opcodes[0x1c2]=(DWORD)&fHasFakeTrait;
	opcodes[0x1c3]=(DWORD)&fAddPerkMode;
	opcodes[0x1c4]=(DWORD)&fClearSelectablePerks;
	opcodes[0x1c5]=(DWORD)&SetCritterHitChance;
	opcodes[0x1c6]=(DWORD)&SetBaseHitChance;
	opcodes[0x1c7]=(DWORD)&SetCritterSkillMod;
	opcodes[0x1c8]=(DWORD)&SetBaseSkillMod;
	opcodes[0x1c9]=(DWORD)&SetCritterPickpocket;
	opcodes[0x1ca]=(DWORD)&SetBasePickpocket;
	opcodes[0x1cb]=(DWORD)&SetPyromaniacMod;
	opcodes[0x1cc]=(DWORD)&fApplyHeaveHoFix;
	opcodes[0x1cd]=(DWORD)SetSwiftLearnerMod;

	Setup=true;
}

void LoadGlobalScripts() {
	if(!Setup) return;
	WIN32_FIND_DATA file;
	HANDLE h=FindFirstFileA("data\\scripts\\gl*.int", &file);
	if(h==INVALID_HANDLE_VALUE) return;
	char* fName=file.cFileName;
	DWORD script;
	DWORD found=1;
	while(found) {
		fName[strlen(fName)-4]=0;
		_asm {
			mov eax, fName;
			mov ebx, 0x004A3B74;
			call ebx;
			mov script, eax;
		}
		if(script) {
			sGlobalScript gscript=sGlobalScript(script);
			globalScripts.push_back(gscript);
			_asm {
				mov edx, -1;
				mov ebx, 0x0046CCA4;
				mov eax, script;
				call ebx;
			}
		}
		found=FindNextFileA(h, &file);
	}
	FindClose(h);	
}

static DWORD _stdcall ScriptHasLoaded(DWORD script) {
	for(DWORD d=0;d<checkedScripts.size();d++) {
		if(checkedScripts[d]==script) return 0;
	}
	checkedScripts.push_back(script);
	return 1;
}

void ClearCheckedScripts() {
	checkedScripts.clear();
	globalScripts.clear(); //memory leak...

	//Reset some settable game values back to the defaults
	//Pyromaniac bonus
	SafeWrite8(0x424AB6, 5);
	//xp mod
	SafeWrite8(0x004AFAB8, 0x53);
	SafeWrite32(0x004AFAB9, 0x55575651);
	//Perk level mod
	SafeWrite32(0x00496880, 0x00019078);
	//Stat ranges
	StatsReset();
}

static void RunScript(sGlobalScript* script) {
	script->count=0;
	DWORD sptr=script->ptr;
	_asm {
		mov edx, 1;
		mov eax, sptr;
		mov ebx, 0x0046DD2C;
		call ebx;
	}
}
static void RunGlobalScripts1() {
	for(DWORD d=0;d<globalScripts.size();d++) {
		if(!globalScripts[d].repeat||(globalScripts[d].mode!=0&&globalScripts[d].mode!=3)) continue;
		if(++globalScripts[d].count>=globalScripts[d].repeat) {
			RunScript(&globalScripts[d]);
		}
	}
}
void RunGlobalScripts2() {
	for(DWORD d=0;d<globalScripts.size();d++) {
		if(!globalScripts[d].repeat||globalScripts[d].mode!=1) continue;
		if(++globalScripts[d].count>=globalScripts[d].repeat) {
			RunScript(&globalScripts[d]);
		}
	}
}
void RunGlobalScripts3() {
	for(DWORD d=0;d<globalScripts.size();d++) {
		if(!globalScripts[d].repeat||(globalScripts[d].mode!=2&&globalScripts[d].mode!=3)) continue;
		if(++globalScripts[d].count>=globalScripts[d].repeat) {
			RunScript(&globalScripts[d]);
		}
	}
}

void LoadGlobals(HANDLE h) {
	DWORD count, unused;
	ReadFile(h, &count, 4, &unused, 0);
	sGlobalVar var;
	for(DWORD i=0;i<count;i++) {
		ReadFile(h, &var, sizeof(sGlobalVar), &unused, 0);
		globalVars.push_back(var);
	}
}
void SaveGlobals(HANDLE h) {
	DWORD count, unused;
	count=globalVars.size();
	WriteFile(h, &count, 4, &unused, 0);
	for(DWORD i=0;i<globalVars.size();i++) {
		WriteFile(h, &globalVars[i], sizeof(sGlobalVar), &unused, 0);
	}
}
void ClearGlobals() {
	globalVars.clear();
}