#include <windows.h>
#include "Stats.h"
#include "SafeWrite.h"
#include "Main.h"

static DWORD StatMaximumsPC[0x23];
static DWORD StatMinimumsPC[0x23];
static DWORD StatMaximumsNPC[0x23];
static DWORD StatMinimumsNPC[0x23];

static DWORD cCritter;

static DWORD xpTable[99];

static void __declspec(naked) GetCurrentStatHook1() {
	_asm {
		mov cCritter, eax;
		push ebx;
		push ecx;
		push esi;
		push edi;
		push ebp;
		mov ebx, 0x004AEF4D;
		jmp ebx;
	}
}
static void __declspec(naked) GetCurrentStatHook2() {
	_asm {
		shl esi, 2;
		mov eax, cCritter;
		cmp eax, dword ptr ds:[0x006610B8];
		je pc;
		cmp ecx, StatMinimumsNPC[esi];
		jg npc1;
		mov eax, StatMinimumsNPC[esi];
		jmp end;
npc1:
		cmp ecx, StatMaximumsNPC[esi];
		jl npc2;
		mov eax, StatMaximumsNPC[esi];
		jmp end;
npc2:
		mov eax, ecx;
		jmp end;
pc:
		cmp ecx, StatMinimumsPC[esi];
		jge pc1;
		mov eax, StatMinimumsPC[esi];
		jmp end;
pc1:
		cmp ecx, StatMaximumsPC[esi];
		jle pc2;
		mov eax, StatMaximumsPC[esi];
		jmp end;
pc2:
		mov eax, ecx;
end:
		mov ebx, 0x004AF3D7;
		jmp ebx;
	}
}

static void __declspec(naked) SetCurrentStatHook() {
	_asm {
		cmp esi, dword ptr ds:[0x006610B8];
		je pc;
		cmp ebx, StatMinimumsNPC[ecx*4];
		jl fail;
		cmp ebx, StatMaximumsNPC[ecx*4];
		jg fail;
		jmp end;
pc:
		cmp ebx, StatMinimumsPC[ecx*4];
		jl fail;
		cmp ebx, StatMaximumsPC[ecx*4];
		jg fail;
		jmp end;
fail:
		mov eax, 0x004AF57E;
		jmp eax;
end:
		mov edx, 0x004AF59C;
		jmp edx;
	}
}

static void _declspec(naked) GetLevelXPHook() {
	_asm {
		dec eax;
		mov eax, [xpTable+eax*4];
		ret;
	}
}
static void _declspec(naked) GetNextLevelXPHook() {
	_asm {
		mov eax, ds:[0x6681B0];
		jmp GetLevelXPHook;
	}
}


void StatsReset() {
	for(int i=0;i<0x23;i++) {
		StatMaximumsPC[i]=StatMaximumsNPC[i]=*(DWORD*)(0x0051D54C + i*24);
		StatMinimumsPC[i]=StatMinimumsNPC[i]=*(DWORD*)(0x0051D548 + i*24);
	}
}
void StatsInit() {
	StatsReset();
	SafeWrite8(0x004AEF48, 0xe9);
	HookCall(0x004AEF48, GetCurrentStatHook1);
	SafeWrite8(0x004AF3AF, 0xe9);
	HookCall(0x004AF3AF, GetCurrentStatHook2);
	SafeWrite8(0x004AF56A, 0xe9);
	HookCall(0x004AF56A, SetCurrentStatHook);

	char table[2048];
	GetPrivateProfileString("Misc", "XPTable", "", table, 2048, ini);
	if(strlen(table)>0) {
		char *ptr=table, *ptr2;
		DWORD level=0;
		
		HookCall(0x434AA7, GetNextLevelXPHook);
		HookCall(0x439642, GetNextLevelXPHook);
		HookCall(0x4AFB22, GetNextLevelXPHook);
		HookCall(0x496C8D, GetLevelXPHook);
		HookCall(0x4AFC53, GetLevelXPHook);

#ifdef WIN9X
		while((ptr2=const_cast<char*>(strstr(ptr, ",")))&&level<99) {
#else
		while((ptr2=strstr(ptr, ","))&&level<99) {
#endif
			ptr2[0]='\0';
			xpTable[level++]=atoi(ptr);
			ptr=ptr2+1;
		}
		if(level<99&&ptr[0]!='\0') {
			xpTable[level++]=atoi(ptr);
		}
		for(int i=level;i<99;i++) xpTable[i]=-1;
		SafeWrite8(0x4AFB1B, (BYTE)(level+1));

	}
}

void _stdcall SetPCStatMax(int stat, int i) {
	if(stat<0||stat>=0x23) return;
	StatMaximumsPC[stat]=i;
}
void _stdcall SetPCStatMin(int stat, int i) {
	if(stat<0||stat>=0x23) return;
	StatMinimumsPC[stat]=i;
}
void _stdcall SetNPCStatMax(int stat, int i) {
	if(stat<0||stat>=0x23) return;
	StatMaximumsNPC[stat]=i;
}
void _stdcall SetNPCStatMin(int stat, int i) {
	if(stat<0||stat>=0x23) return;
	StatMinimumsNPC[stat]=i;
}