#ifdef WIN9X

#define WIN32_LEAN_AND_MEAN
#define STRICT
#include <windows.h>

//A collection of messy hacks required to compile something that runs on win95 using VS2005
//A better option would be to exclude this file and win9x.h and then compile with VS6

extern "C" 
{
int _fltused = 0; //Not sure what this is for, but removing it causes a pile of unresolved external symbol errors...

int atoi(const char* str) {
	DWORD res=0;
	while(true) {
		switch(str[0]) {
			case 0:
				res*=10;
				break;
			case 1:
				res*=10;
				res+=1;
				break;
			case 2:
				res*=10;
				res+=2;
				break;
			case 3:
				res*=10;
				res+=3;
				break;
			case 4:
				res*=10;
				res+=4;
				break;
			case 5:
				res*=10;
				res+=5;
				break;
			case 6:
				res*=10;
				res+=6;
				break;
			case 7:
				res*=10;
				res+=7;
				break;
			case 8:
				res*=10;
				res+=8;
				break;
			case 9:
				res*=10;
				res+=9;
				break;
			default: return res;
		}
	}
}
}

static HANDLE heap;

//strcat is a compiler intrinsic that doesn't require the standard libraries if /Oi compiler option is used
void strcat_s(char* a, const char* b) { strcat(a,b); }
void strcat_s(char* a, int i, const char* b) { strcat(a,b); }
void strcpy_s(char* a, const char* b) { strcpy(a,b); }
void strcpy_s(char* a, int i, const char* b) { strcpy(a,b); }

//Just use fallout's function for itoa
void _cdecl _itoa_s(int val, char* buf, int redix) {
	_asm {
		mov eax, val;
		mov ebx, redix;
		mov edx, buf;
		mov ecx, 0x004F0CC0;
		call ecx;
	}
}
void _cdecl _itoa_s(int val, char* buf, int i, int redix) { _itoa_s(val, buf, redix); }

double _declspec(naked) _cdecl modf(double x, double *ipart) {
	_asm {
		fld qword ptr [esp+4];
		fld1;
		fld st(1);
		fprem;
		fld st(0);
		fsubr st(0), st(3);//Integer part in st(0), remainder in st(1)
		mov eax, [esp+12];
		fstp qword ptr [eax];
		fxch st(2);
		fstp [esp-8];
		fstp [esp-8];
		retn;
	}
}

//Memory handling. Probably best not to look at it...
void memInit() { heap=GetProcessHeap(); }
void *operator new (size_t a) { return HeapAlloc(heap, 0, a); }
void operator delete (void * a) { HeapFree(heap, 0, a); }
void *operator new[] (size_t a) { return HeapAlloc(heap, 0, a); }
void operator delete[] (void * a) { HeapFree(heap, 0, a); }

void memcpy2(void* to, const void* from, int size) {
	for(int i=0;i<size;i++) ((char*)to)[i]=((char*)from)[i];
}
void memset2(void* to, char val, int size_t) {
	//Need to do this in asm, or it gets optimized to a memset which then triggers the undefined external symbol error again
	_asm {
		mov ebx, to;
		xor eax, eax
		mov al, val;
		mov ecx, size_t;
l:
		mov byte ptr ds:[ebx], al;
		inc eax;
		loop l;
	}
	//for(int i=0;i<size;i++) ((char*)to)[i]=val;
}

extern "C" {
	//The compiler always uses the sse version unless favour small code is set, regardless of the chosen instruction set option
	DWORD _declspec(naked) _ftol2_sse(double f) { 
		__asm {
			fnstcw [esp-4];
			mov ax, 0x037f;
			mov [esp-6], ax;
			fldcw [esp-6];
			fistp dword ptr [esp-8];
			mov eax, [esp-8];
			fldcw [esp-4];
			retn;
		}
	}
	//This is microsofts reference implementation.
	__declspec(naked) void __cdecl _alldiv(void)
{
    __asm {
        push    edi
        push    esi
        push    ebx

#define DVNDLO  [esp + 16]      /* stack address of dividend (a) loword */
#define DVNDHI  [esp + 20]      /* stack address of dividend (a) hiword */
#define DVSRLO  [esp + 24]      /* stack address of divisor (b) loword */
#define DVSRHI  [esp + 28]      /* stack address of divisor (b) hiword */


        xor     edi,edi         // result sign assumed positive

        mov     eax,DVNDHI      // hi word of a
        or      eax,eax         // test to see if signed
        jge     short L1        // skip rest if a is already positive
        inc     edi             // complement result sign flag
        mov     edx,DVNDLO      // lo word of a
        neg     eax             // make a positive
        neg     edx
        sbb     eax,0
        mov     DVNDHI,eax      // save positive value
        mov     DVNDLO,edx
L1:
        mov     eax,DVSRHI      // hi word of b
        or      eax,eax         // test to see if signed
        jge     short L2        // skip rest if b is already positive
        inc     edi             // complement the result sign flag
        mov     edx,DVSRLO      // lo word of a
        neg     eax             // make b positive
        neg     edx
        sbb     eax,0
        mov     DVSRHI,eax      // save positive value
        mov     DVSRLO,edx
L2:

        or      eax,eax         // check to see if divisor < 4194304K
        jnz     short L3        // nope, gotta do this the hard way
        mov     ecx,DVSRLO      // load divisor
        mov     eax,DVNDHI      // load high word of dividend
        xor     edx,edx
        div     ecx             // eax <- high order bits of quotient
        mov     ebx,eax         // save high bits of quotient
        mov     eax,DVNDLO      // edx:eax <- remainder:lo word of dividend
        div     ecx             // eax <- low order bits of quotient
        mov     edx,ebx         // edx:eax <- quotient
        jmp     short L4        // set sign, restore stack and return

L3:
        mov     ebx,eax         // ebx:ecx <- divisor
        mov     ecx,DVSRLO
        mov     edx,DVNDHI      // edx:eax <- dividend
        mov     eax,DVNDLO
L5:
        shr     ebx,1           // shift divisor right one bit
        rcr     ecx,1
        shr     edx,1           // shift dividend right one bit
        rcr     eax,1
        or      ebx,ebx
        jnz     short L5        // loop until divisor < 4194304K
        div     ecx             // now divide, ignore remainder
        mov     esi,eax         // save quotient

        mul     dword ptr DVSRHI // QUOT * DVSRHI
        mov     ecx,eax
        mov     eax,DVSRLO
        mul     esi             // QUOT * DVSRLO
        add     edx,ecx         // EDX:EAX = QUOT * DVSR
        jc      short L6        // carry means Quotient is off by 1

        cmp     edx,DVNDHI      // compare hi words of result and original
        ja      short L6        // if result > original, do subtract
        jb      short L7        // if result < original, we are ok
        cmp     eax,DVNDLO      // hi words are equal, compare lo words
        jbe     short L7        // if less or equal we are ok, else subtract
L6:
        dec     esi             // subtract 1 from quotient
L7:
        xor     edx,edx         // edx:eax <- quotient
        mov     eax,esi

//
// Just the cleanup left to do.  edx:eax contains the quotient.  Set the sign
// according to the save value, cleanup the stack, and return.
//

L4:
        dec     edi             // check to see if result is negative
        jnz     short L8        // if EDI == 0, result should be negative
        neg     edx             // otherwise, negate the result
        neg     eax
        sbb     edx,0

//
// Restore the saved registers and return.
//

L8:
        pop     ebx
        pop     esi
        pop     edi

        ret     16
    }
}


}

double _cdecl floor(double d) {
	double ipart;
	modf(d, &ipart);
	return ipart;
}

const char* strstr2(const char* a,const char* b) {
	int pos=0;
	while(*a) {
		if(*a==*b) {
			while(b[pos]) {
				if(b[pos]==a[pos]) pos++;
				else break;
			}
			if(!*b) return const_cast<char*>(a);
			pos=0;
		}
	}
	return 0;
}

#endif